/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern2 (x3); /* [-1, 1] */
}

int
pattern10 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_fp_vec_pow2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  return pattern15 (x1); /* [-1, 1] */
}

int
pattern19 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 307
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  return pattern22 (x3); /* [-1, 3] */
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !aarch64_reg_or_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 0;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern42 (x2); /* [-1, 1] */
}

int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_comparison_operator (operands[1], i1))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 6;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 7;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode))
        return -1;
      return 9;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !register_operand (operands[1], E_V8BFmode))
        return -1;
      return 10;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 11;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 12;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern77 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern77 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern77 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern77 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_QImode:
      if (pattern77 (x3, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_HImode:
      if (pattern77 (x3, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern77 (x3, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern77 (x3, 
E_DImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return pattern111 (
E_VNx8QImode, 
E_VNx4QImode, 
E_VNx2QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern112 (x3, 
E_VNx8HImode, 
E_VNx4HImode, 
E_VNx2HImode, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    case E_SImode:
      res = pattern113 (x3, 
E_VNx4SImode, 
E_VNx2SImode, 
E_SImode);
      if (res >= 0)
        return res + 7; /* [7, 8] */
      return -1;

    case E_DImode:
      if (pattern90 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 9;

    case E_HFmode:
      res = pattern112 (x3, 
E_VNx8HFmode, 
E_VNx4HFmode, 
E_VNx2HFmode, 
E_HFmode);
      if (res >= 0)
        return res + 10; /* [10, 12] */
      return -1;

    case E_BFmode:
      res = pattern112 (x3, 
E_VNx8BFmode, 
E_VNx4BFmode, 
E_VNx2BFmode, 
E_BFmode);
      if (res >= 0)
        return res + 13; /* [13, 15] */
      return -1;

    case E_SFmode:
      res = pattern113 (x3, 
E_VNx4SFmode, 
E_VNx2SFmode, 
E_SFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_DFmode:
      if (pattern90 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern124 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern124 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern124 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern124 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern124 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern124 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern77 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern153 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern153 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern154 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern154 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern155 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern155 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern156 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern156 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern178 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[2], E_VNx4SFmode))
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern186 (x3, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern186 (x3, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern186 (x3, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern186 (x3, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (pattern186 (x3, 
E_VNx16BFmode) != 0)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (pattern186 (x3, 
E_VNx16HFmode) != 0)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (pattern186 (x3, 
E_VNx8SFmode) != 0)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (pattern186 (x3, 
E_VNx4DFmode) != 0)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (pattern186 (x3, 
E_VNx64QImode) != 0)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (pattern186 (x3, 
E_VNx32HImode) != 0)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (pattern186 (x3, 
E_VNx16SImode) != 0)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (pattern186 (x3, 
E_VNx8DImode) != 0)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (pattern186 (x3, 
E_VNx32BFmode) != 0)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (pattern186 (x3, 
E_VNx32HFmode) != 0)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (pattern186 (x3, 
E_VNx16SFmode) != 0)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (pattern186 (x3, 
E_VNx8DFmode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_maxmin_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  return pattern211 (x3); /* [-1, 3] */
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern217 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern217 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern217 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16HImode)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (!aligned_register_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x1) != E_VNx8SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8SImode)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DImode)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16BFmode)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16HFmode)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x1) != E_VNx8SFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8SFmode)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (!aligned_register_operand (operands[0], E_VNx4DFmode)
          || GET_MODE (x1) != E_VNx4DFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DFmode)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx64QImode)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32HImode)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x1) != E_VNx16SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16SImode)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DImode)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32BFmode)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx32HFmode)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x1) != E_VNx16SFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx16SFmode)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x1) != E_VNx8DFmode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DFmode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      x8 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[2] = x8;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx16QImode:
                  if (!register_operand (operands[1], E_VNx16QImode)
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 0;

                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 1;

                case E_VNx32QImode:
                  if (!aligned_register_operand (operands[1], E_VNx32QImode)
                      || !aligned_register_operand (operands[2], E_VNx32QImode))
                    return -1;
                  return 2;

                case E_VNx64QImode:
                  if (!aligned_register_operand (operands[1], E_VNx64QImode)
                      || !aligned_register_operand (operands[2], E_VNx64QImode))
                    return -1;
                  return 3;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || !aligned_register_operand (operands[2], E_VNx16HImode))
                    return -1;
                  return 4;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || !aligned_register_operand (operands[2], E_VNx32HImode))
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 6;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || !aligned_register_operand (operands[2], E_VNx16HImode))
                    return -1;
                  return 7;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || !aligned_register_operand (operands[2], E_VNx32HImode))
                    return -1;
                  return 8;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              res = pattern244 (x2, 
E_VNx4SImode);
              if (res >= 0)
                return res + 9; /* [9, 12] */
              return -1;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx16HImode:
                  if (!register_operand (operands[1], E_VNx16HImode)
                      || GET_MODE (x8) != E_VNx16HImode)
                    return -1;
                  return 13;

                case E_VNx32HImode:
                  if (!register_operand (operands[1], E_VNx32HImode)
                      || GET_MODE (x8) != E_VNx32HImode)
                    return -1;
                  return 14;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 168)
            return -1;
          x10 = XVECEXP (x8, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x8, 0, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx16QImode:
                  if (!register_operand (operands[1], E_VNx16QImode)
                      || GET_MODE (x8) != E_VNx16QImode
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 15;

                case E_VNx32QImode:
                  if (!aligned_register_operand (operands[1], E_VNx32QImode)
                      || GET_MODE (x8) != E_VNx32QImode
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 16;

                case E_VNx64QImode:
                  if (!aligned_register_operand (operands[1], E_VNx64QImode)
                      || GET_MODE (x8) != E_VNx64QImode
                      || !register_operand (operands[2], E_VNx16QImode))
                    return -1;
                  return 17;

                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || GET_MODE (x8) != E_VNx8HImode
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 18;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || GET_MODE (x8) != E_VNx16HImode
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 19;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || GET_MODE (x8) != E_VNx32HImode
                      || !register_operand (operands[2], E_VNx8HImode))
                    return -1;
                  return 20;

                default:
                  return -1;
                }

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_VNx8HImode:
                  if (!register_operand (operands[1], E_VNx8HImode)
                      || GET_MODE (x8) != E_VNx8HImode)
                    return -1;
                  return 21;

                case E_VNx16HImode:
                  if (!aligned_register_operand (operands[1], E_VNx16HImode)
                      || GET_MODE (x8) != E_VNx16HImode)
                    return -1;
                  return 22;

                case E_VNx32HImode:
                  if (!aligned_register_operand (operands[1], E_VNx32HImode)
                      || GET_MODE (x8) != E_VNx32HImode)
                    return -1;
                  return 23;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x6, 1);
      operands[1] = x13;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 24;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode)
                return -1;
              return 25;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 26;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !const_0_to_4_step_4_operand (operands[1], E_SImode))
                return -1;
              res = pattern253 (x8);
              if (res >= 0)
                return res + 27; /* [27, 28] */
              return -1;

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 168)
            return -1;
          x10 = XVECEXP (x8, 0, 0);
          operands[3] = x10;
          x11 = XVECEXP (x8, 0, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_VNx4SImode:
              if (GET_MODE (x2) != E_VNx4SImode
                  || GET_MODE (x3) != E_VNx4SImode)
                return -1;
              return 29;

            case E_VNx2DImode:
              if (GET_MODE (x2) != E_VNx2DImode
                  || GET_MODE (x3) != E_VNx2DImode
                  || !register_operand (operands[3], E_VNx8HImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern346 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern346 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 5
      || GET_MODE (x1) != E_DImode)
    return -1;
  return 0;
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern369 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern373 (rtx x1, unsigned int i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  return pattern375 (x1); /* [-1, 1] */
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!aarch64_any_register_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x1) != E_VNx8QImode)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x1) != E_VNx4QImode)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x1) != E_VNx4HImode)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x1) != E_VNx2HImode)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x1) != E_VNx2SImode)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x1) != E_VNx4HFmode)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x1) != E_VNx2HFmode)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x1) != E_VNx4BFmode)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x1) != E_VNx2BFmode)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x1) != E_VNx2SFmode)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (XINT (x2, 1))
    {
    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          return pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode); /* [-1, 0] */

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 358:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 3;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 4;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 6;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 7;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case 364:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 9;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 10;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case 365:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 12;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 13;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 14;

        default:
          return -1;
        }

    case 366:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern412 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 15;

        case E_VNx4BImode:
          if (pattern412 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 16;

        case E_VNx2BImode:
          if (pattern412 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case 367:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern413 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 18;

        case E_VNx4BImode:
          if (pattern413 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 19;

        case E_VNx2BImode:
          if (pattern413 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern446 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_sqadd_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern22 (x1);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern459 (x1, 
E_V16QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern459 (x1, 
E_V8HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern459 (x1, 
E_V4SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern459 (x1, 
E_V2DImode, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern469 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4HImode:
          return pattern468 (x2, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern468 (x2, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2SImode:
          if (pattern468 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern468 (x2, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2DImode:
          if (pattern468 (x2, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern468 (x2, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern484 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern486 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern486 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern486 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern486 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern486 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern486 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern486 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern486 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern486 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern486 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern505 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern505 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern505 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern505 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || GET_MODE (x2) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  return 0;
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!aarch64_imm3 (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern518 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern518 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern526 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern535 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern533 (x1); /* [-1, 5] */

    case ABS:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ABS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern534 (x1, 
E_V4HFmode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern534 (x1, 
E_V2SFmode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_V2DImode:
          if (pattern534 (x1, 
E_DFmode, 
E_DImode, 
E_V2DImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern548 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern541 (x1); /* [-1, 2] */

    case PLUS:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern543 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern545 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern547 (x1, 
E_V2DImode, 
E_V2TImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern560 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case TRUNCATE:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x1, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern559 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern559 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern559 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      res = pattern435 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case REG:
    case SUBREG:
      res = pattern436 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern580 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  return pattern361 (x1); /* [-1, 3] */
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldnf1_operand (operands[1], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != XOR)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  operands[4] = x6;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern605 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern605 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern605 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern605 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return pattern331 (x3); /* [-1, 4] */
}

int
pattern620 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_hi_half (operands[4], i3))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern634 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 1] */

    case E_V4SImode:
      res = pattern634 (x1, 
E_V4SImode, 
E_V16QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_borrow_operation (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_MODE (x8) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 0;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_MODE (x8) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 2;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern654 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern654 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern685 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern683 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern683 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern683 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern684 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern684 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern684 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern698 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern696 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern696 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern696 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern696 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    case E_VNx8BFmode:
      if (pattern697 (x1, 
E_VNx8HImode, 
E_VNx8BFmode) != 0)
        return -1;
      return 4;

    case E_VNx8HFmode:
      if (pattern697 (x1, 
E_VNx8HImode, 
E_VNx8HFmode) != 0)
        return -1;
      return 5;

    case E_VNx4SFmode:
      if (pattern697 (x1, 
E_VNx4SImode, 
E_VNx4SFmode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern697 (x1, 
E_VNx2DImode, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    case E_VNx32QImode:
      if (!aligned_register_operand (operands[0], E_VNx32QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32QImode
          || pattern695 (x1, 
E_VNx32QImode) != 0)
        return -1;
      return 8;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[0], E_VNx16HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16HImode
          || pattern695 (x1, 
E_VNx16HImode) != 0)
        return -1;
      return 9;

    case E_VNx8SImode:
      if (!aligned_register_operand (operands[0], E_VNx8SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8SImode
          || pattern695 (x1, 
E_VNx8SImode) != 0)
        return -1;
      return 10;

    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx4DImode
          || pattern695 (x1, 
E_VNx4DImode) != 0)
        return -1;
      return 11;

    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[0], E_VNx16BFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16BFmode
          || pattern695 (x1, 
E_VNx16BFmode) != 0)
        return -1;
      return 12;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[0], E_VNx16HFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16HFmode
          || pattern695 (x1, 
E_VNx16HFmode) != 0)
        return -1;
      return 13;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8SFmode
          || pattern695 (x1, 
E_VNx8SFmode) != 0)
        return -1;
      return 14;

    case E_VNx4DFmode:
      if (!aligned_register_operand (operands[0], E_VNx4DFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx4DFmode
          || pattern695 (x1, 
E_VNx4DFmode) != 0)
        return -1;
      return 15;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx64QImode
          || pattern695 (x1, 
E_VNx64QImode) != 0)
        return -1;
      return 16;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32HImode
          || pattern695 (x1, 
E_VNx32HImode) != 0)
        return -1;
      return 17;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16SImode
          || pattern695 (x1, 
E_VNx16SImode) != 0)
        return -1;
      return 18;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8DImode
          || pattern695 (x1, 
E_VNx8DImode) != 0)
        return -1;
      return 19;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32BFmode
          || pattern695 (x1, 
E_VNx32BFmode) != 0)
        return -1;
      return 20;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32HFmode
          || pattern695 (x1, 
E_VNx32HFmode) != 0)
        return -1;
      return 21;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16SFmode
          || pattern695 (x1, 
E_VNx16SFmode) != 0)
        return -1;
      return 22;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8DFmode
          || pattern695 (x1, 
E_VNx8DFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern754 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_imm24 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern760 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern767 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern776 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern782 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_Zmode
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V2x16QImode:
      if (!register_operand (operands[2], E_V2x16QImode))
        return -1;
      return 1;

    case E_V3x16QImode:
      if (!register_operand (operands[2], E_V3x16QImode))
        return -1;
      return 2;

    case E_V4x16QImode:
      if (!register_operand (operands[2], E_V4x16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern813 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern825 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern832 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern831 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern831 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern831 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern844 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_imm_zero (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern850 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern849 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern849 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern849 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern860 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[2]))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern858 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern858 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern858 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern858 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern859 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern859 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern859 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DImode:
          if (pattern859 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern884 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern889 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  return pattern888 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern895 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_plus_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_plus_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern901 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern906 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern913 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern923 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x3, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return pattern922 (x1); /* [-1, 1] */
}

int
pattern930 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern615 (x4); /* [-1, 3] */
}

int
pattern934 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_general_reg (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_plus_immediate (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern938 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode)
          || !memory_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode)
          || !memory_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode)
          || !memory_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode)
          || !memory_operand (operands[3], E_V2DImode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[2], E_V8HFmode)
          || !memory_operand (operands[3], E_V8HFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[2], E_V4SFmode)
          || !memory_operand (operands[3], E_V4SFmode))
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[2], E_V2DFmode)
          || !memory_operand (operands[3], E_V2DFmode))
        return -1;
      return 6;

    case E_V8BFmode:
      if (!register_operand (operands[2], E_V8BFmode)
          || !memory_operand (operands[3], E_V8BFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern956 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern963 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1002 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode))
            return -1;
          return 1;

        case E_VNx16HImode:
          if (!register_operand (operands[1], E_VNx16HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode))
            return -1;
          return 3;

        case E_VNx16HFmode:
          if (!register_operand (operands[1], E_VNx16HFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode))
            return -1;
          return 5;

        case E_VNx16BFmode:
          if (!register_operand (operands[1], E_VNx16BFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1026 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern1025 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1025 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1025 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1034 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1041 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern1055 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1062 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1080 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode)
      || GET_MODE (x2) != E_V2SImode
      || !register_operand (operands[2], E_V8QImode)
      || !immediate_operand (operands[4], E_SImode)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1093 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1102 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1044 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1105 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1105 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1105 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1109 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1109 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1109 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1109 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1109 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1109 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1145 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1162 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16BImode)
          || !register_operand (operands[3], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8BImode)
          || !register_operand (operands[3], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4BImode)
          || !register_operand (operands[3], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx2BImode
          || !register_operand (operands[2], E_VNx2BImode)
          || !register_operand (operands[3], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1196 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1196 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1196 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1196 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1)
      || !const_scalar_int_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !aarch64_plus_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1212 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_hi_half (operands[4], i2))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1182 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1226 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_h (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1245 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1249 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_VNx16BImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  return pattern1247 (x1, 
i1); /* [-1, 1] */
}

int
pattern1258 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern464 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern464 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern464 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1284 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], E_VNx2BImode)
      || !aarch64_sve_gather_offset_d (operands[1], E_DImode)
      || !register_operand (operands[2], E_VNx2DImode)
      || !aarch64_gather_scale_operand_d (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern1291 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      return pattern1193 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (pattern1193 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (pattern1193 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (pattern1193 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1316 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!aarch64_imm3 (operands[3], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1315 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1315 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1326 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || !aligned_register_operand (operands[3], E_VNx16HImode))
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || !aligned_register_operand (operands[3], E_VNx32HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1333 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != 126)
        return -1;
      x10 = XVECEXP (x9, 0, 2);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      x12 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x12, operands[6]))
        return -1;
      x13 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x13, operands[7]))
        return -1;
      x14 = XEXP (x10, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x10, 1);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x9) != E_VNx16BImode
              || GET_MODE (x10) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x9) != E_VNx8BImode
              || GET_MODE (x10) != E_VNx8BImode)
            return -1;
          res = pattern1330 ();
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x9) != E_VNx4BImode
              || GET_MODE (x10) != E_VNx4BImode)
            return -1;
          res = pattern1331 ();
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x9) != E_VNx2BImode
              || GET_MODE (x10) != E_VNx2BImode)
            return -1;
          res = pattern1332 ();
          if (res >= 0)
            return res + 6; /* [6, 9] */
          return -1;

        default:
          return -1;
        }

    case CLOBBER:
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 10;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          res = pattern1330 ();
          if (res >= 0)
            return res + 11; /* [11, 12] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          res = pattern1331 ();
          if (res >= 0)
            return res + 13; /* [13, 15] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          res = pattern1332 ();
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      x9 = XEXP (x4, 1);
      operands[4] = x9;
      x10 = XEXP (x3, 1);
      operands[5] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1115 (x2, 
E_SImode) != 0
              || !aarch64_simd_shift_imm_si (operands[4], E_SImode)
              || !const_int_operand (operands[5], E_SImode)
              || !
#line 6491 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]),
				      UINTVAL (operands[4]),
				      UINTVAL(operands[5]))))
            return -1;
          return 850; /* *aarch64_bfisi5_shift */

        case E_DImode:
          if (pattern1115 (x2, 
E_DImode) != 0
              || !aarch64_simd_shift_imm_di (operands[4], E_DImode)
              || !const_int_operand (operands[5], E_DImode)
              || !
#line 6491 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]),
				      UINTVAL (operands[4]),
				      UINTVAL(operands[5]))))
            return -1;
          return 851; /* *aarch64_bfidi5_shift */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern792 (x2, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (GET_MODE (x3) == E_SImode)
            {
              operands[3] = x4;
              if (register_operand (operands[3], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (const_int_operand (operands[4], E_SImode)
                      && 
#line 6560 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 858; /* *aarch64_bfisi4_noshift */
                }
            }
          operands[4] = x7;
          operands[3] = x6;
          if (GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[2] = x10;
                  if (const_int_operand (operands[2], E_SImode)
                      && 
#line 6572 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 860; /* *aarch64_bfisi4_noshift_alt */
                }
            }
          operands[3] = x7;
          operands[1] = x6;
          if (GET_MODE (x3) != E_SImode)
            return -1;
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_SImode)
              || !
#line 6720 "../../gcc/config/aarch64/aarch64.md"
((INTVAL (operands[3]) == ~INTVAL (operands[4]))
  && (aarch64_high_bits_all_ones_p (INTVAL (operands[3]))
    || aarch64_high_bits_all_ones_p (INTVAL (operands[4])))))
            return -1;
          return 887; /* *aarch64_bfxilsi */

        case E_DImode:
          if (pattern792 (x2, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (GET_MODE (x3) == E_DImode)
            {
              operands[3] = x4;
              if (register_operand (operands[3], E_DImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (const_int_operand (operands[4], E_DImode)
                      && 
#line 6560 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 859; /* *aarch64_bfidi4_noshift */
                }
            }
          operands[4] = x7;
          operands[3] = x6;
          if (GET_MODE (x3) == E_DImode)
            {
              operands[1] = x4;
              if (register_operand (operands[1], E_DImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[2] = x10;
                  if (const_int_operand (operands[2], E_DImode)
                      && 
#line 6572 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]), 0,
				      UINTVAL (operands[4]))))
                    return 861; /* *aarch64_bfidi4_noshift_alt */
                }
            }
          operands[3] = x7;
          operands[1] = x6;
          if (GET_MODE (x3) != E_DImode)
            return -1;
          operands[2] = x4;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 6720 "../../gcc/config/aarch64/aarch64.md"
((INTVAL (operands[3]) == ~INTVAL (operands[4]))
  && (aarch64_high_bits_all_ones_p (INTVAL (operands[3]))
    || aarch64_high_bits_all_ones_p (INTVAL (operands[4])))))
            return -1;
          return 888; /* *aarch64_bfxildi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 3382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2725; /* reduc_plus_scal_v8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 3382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2726; /* reduc_plus_scal_v16qi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 3382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2727; /* reduc_plus_scal_v4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 3382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2728; /* reduc_plus_scal_v8hi */

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 3382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2729; /* reduc_plus_scal_v4si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 3391 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2731; /* reduc_plus_scal_v2si */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3382 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2730; /* reduc_plus_scal_v2di */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern467 (x3))
        {
        case 0:
          if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2742; /* aarch64_saddlvv8qi */

        case 1:
          if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2744; /* aarch64_saddlvv16qi */

        case 2:
          if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2746; /* aarch64_saddlvv4hi */

        case 3:
          if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2748; /* aarch64_saddlvv8hi */

        case 4:
          if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2750; /* aarch64_saddlvv4si */

        case 5:
          if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2752; /* aarch64_saddlvv2si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern467 (x3))
            {
            case 0:
              if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2743; /* aarch64_uaddlvv8qi */

            case 1:
              if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2745; /* aarch64_uaddlvv16qi */

            case 2:
              if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2747; /* aarch64_uaddlvv4hi */

            case 3:
              if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2749; /* aarch64_uaddlvv8hi */

            case 4:
              if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2751; /* aarch64_uaddlvv4si */

            case 5:
              if (!
#line 3438 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2753; /* aarch64_uaddlvv2si */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern591 (x3))
            {
            case 0:
              if (!
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2766; /* *aarch64_uaddlvv8qi_reduction_2 */

            case 1:
              if (!
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2767; /* *aarch64_uaddlvv16qi_reduction_2 */

            case 2:
              if (!
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2768; /* *aarch64_uaddlvv4hi_reduction_2 */

            case 3:
              if (!
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
                return -1;
              return 2769; /* *aarch64_uaddlvv8hi_reduction_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern470 (x3))
        {
        case 0:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2754; /* *aarch64_saddlvv8qi_reduction */

        case 1:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2756; /* *aarch64_saddlvv16qi_reduction */

        case 2:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2758; /* *aarch64_saddlvv4hi_reduction */

        case 3:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2760; /* *aarch64_saddlvv8hi_reduction */

        case 4:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2762; /* *aarch64_saddlvv4si_reduction */

        case 5:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2764; /* *aarch64_saddlvv2si_reduction */

        case 6:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2755; /* *aarch64_uaddlvv8qi_reduction */

        case 7:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2757; /* *aarch64_uaddlvv16qi_reduction */

        case 8:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2759; /* *aarch64_uaddlvv4hi_reduction */

        case 9:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2761; /* *aarch64_uaddlvv8hi_reduction */

        case 10:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2763; /* *aarch64_uaddlvv4si_reduction */

        case 11:
          if (!
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])))
            return -1;
          return 2765; /* *aarch64_uaddlvv2si_reduction */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern61 (x1))
    {
    case 0:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5025; /* aarch64_rev32v8qi */

    case 1:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5032; /* aarch64_rev32v16qi */

    case 2:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5037; /* aarch64_rev32v4hi */

    case 3:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5044; /* aarch64_rev32v8hi */

    case 4:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5049; /* aarch64_rev32v2si */

    case 5:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5056; /* aarch64_rev32v4si */

    case 6:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5059; /* aarch64_rev32v2di */

    case 7:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5064; /* aarch64_rev32v4hf */

    case 8:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5071; /* aarch64_rev32v8hf */

    case 9:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5076; /* aarch64_rev32v4bf */

    case 10:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5083; /* aarch64_rev32v8bf */

    case 11:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5088; /* aarch64_rev32v2sf */

    case 12:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5095; /* aarch64_rev32v4sf */

    case 13:
      if (!
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5098; /* aarch64_rev32v2df */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 8847 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 5162; /* aarch64_frecpxhf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 8847 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5163; /* aarch64_frecpxsf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 8847 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5164; /* aarch64_frecpxdf */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern72 (x1))
    {
    case 0:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12922; /* aarch64_sve_zipqvnx64qi */

    case 1:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12924; /* aarch64_sve_zipqvnx32hi */

    case 2:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12926; /* aarch64_sve_zipqvnx16si */

    case 3:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12928; /* aarch64_sve_zipqvnx8di */

    case 4:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12930; /* aarch64_sve_zipqvnx32bf */

    case 5:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12932; /* aarch64_sve_zipqvnx32hf */

    case 6:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12934; /* aarch64_sve_zipqvnx16sf */

    case 7:
      if (!
#line 3903 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12936; /* aarch64_sve_zipqvnx8df */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !aarch64_valid_symref (operands[1], E_SImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
        return -1;
      return 1130; /* ldr_got_tiny_si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !aarch64_valid_symref (operands[1], E_DImode)
          || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
        return -1;
      return 1131; /* ldr_got_tiny_di */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern68 (x1))
    {
    case 0:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10837; /* aarch64_sve_uunpklo_vnx16qi */

    case 1:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10841; /* aarch64_sve_uunpklo_vnx8hi */

    case 2:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10845; /* aarch64_sve_uunpklo_vnx4si */

    case 3:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10984; /* aarch64_sve_punpklo_vnx16bi */

    case 4:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10986; /* aarch64_sve_punpklo_vnx8bi */

    case 5:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10988; /* aarch64_sve_punpklo_vnx4bi */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern474 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6571; /* aarch64_pred_one_cmplvnx16qi */

        case E_VNx8QImode:
          if (pattern474 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6580; /* aarch64_pred_one_cmplvnx8qi */

        case E_VNx4QImode:
          if (pattern474 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6589; /* aarch64_pred_one_cmplvnx4qi */

        case E_VNx2QImode:
          if (pattern474 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6598; /* aarch64_pred_one_cmplvnx2qi */

        case E_VNx8HImode:
          if (pattern474 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6607; /* aarch64_pred_one_cmplvnx8hi */

        case E_VNx4HImode:
          if (pattern474 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6616; /* aarch64_pred_one_cmplvnx4hi */

        case E_VNx2HImode:
          if (pattern474 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6625; /* aarch64_pred_one_cmplvnx2hi */

        case E_VNx4SImode:
          if (pattern474 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6634; /* aarch64_pred_one_cmplvnx4si */

        case E_VNx2SImode:
          if (pattern474 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6643; /* aarch64_pred_one_cmplvnx2si */

        case E_VNx2DImode:
          if (pattern474 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6652; /* aarch64_pred_one_cmplvnx2di */

        case E_V8QImode:
          if (pattern474 (x2, 
E_V8QImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6661; /* aarch64_pred_one_cmplv8qi */

        case E_V16QImode:
          if (pattern474 (x2, 
E_V16QImode, 
E_VNx16BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6670; /* aarch64_pred_one_cmplv16qi */

        case E_V4HImode:
          if (pattern474 (x2, 
E_V4HImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6679; /* aarch64_pred_one_cmplv4hi */

        case E_V8HImode:
          if (pattern474 (x2, 
E_V8HImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6688; /* aarch64_pred_one_cmplv8hi */

        case E_V2SImode:
          if (pattern474 (x2, 
E_V2SImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6697; /* aarch64_pred_one_cmplv2si */

        case E_V4SImode:
          if (pattern474 (x2, 
E_V4SImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6706; /* aarch64_pred_one_cmplv4si */

        case E_V2DImode:
          if (pattern474 (x2, 
E_V2DImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6715; /* aarch64_pred_one_cmplv2di */

        case E_V1DImode:
          if (pattern474 (x2, 
E_V1DImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6724; /* aarch64_pred_one_cmplv1di */

        default:
          return -1;
        }

    case XOR:
      switch (pattern606 (x2))
        {
        case 0:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11954; /* *aarch64_sve2_nbslvnx16qi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11955; /* *aarch64_sve2_nbslvnx16qi */

        case 1:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11956; /* *aarch64_sve2_nbslvnx8hi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11957; /* *aarch64_sve2_nbslvnx8hi */

        case 2:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11958; /* *aarch64_sve2_nbslvnx4si */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11959; /* *aarch64_sve2_nbslvnx4si */

        case 3:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11960; /* *aarch64_sve2_nbslvnx2di */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11961; /* *aarch64_sve2_nbslvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern475 (x2))
    {
    case 0:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6574; /* aarch64_pred_popcountvnx16qi */

    case 1:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6583; /* aarch64_pred_popcountvnx8qi */

    case 2:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6592; /* aarch64_pred_popcountvnx4qi */

    case 3:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6601; /* aarch64_pred_popcountvnx2qi */

    case 4:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6610; /* aarch64_pred_popcountvnx8hi */

    case 5:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6619; /* aarch64_pred_popcountvnx4hi */

    case 6:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6628; /* aarch64_pred_popcountvnx2hi */

    case 7:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6637; /* aarch64_pred_popcountvnx4si */

    case 8:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6646; /* aarch64_pred_popcountvnx2si */

    case 9:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6655; /* aarch64_pred_popcountvnx2di */

    case 10:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6664; /* aarch64_pred_popcountv8qi */

    case 11:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6673; /* aarch64_pred_popcountv16qi */

    case 12:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6682; /* aarch64_pred_popcountv4hi */

    case 13:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6691; /* aarch64_pred_popcountv8hi */

    case 14:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6700; /* aarch64_pred_popcountv2si */

    case 15:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6709; /* aarch64_pred_popcountv4si */

    case 16:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6718; /* aarch64_pred_popcountv2di */

    case 17:
      if (!
#line 3200 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6727; /* aarch64_pred_popcountv1di */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern77 (x3, 
E_HFmode) != 0
                  || !(
#line 7431 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                return -1;
              return 1101; /* fminhf3 */

            case E_SFmode:
              if (pattern77 (x3, 
E_SFmode) != 0
                  || !
#line 7431 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1105; /* fminsf3 */

            case E_DFmode:
              if (pattern77 (x3, 
E_DFmode) != 0
                  || !
#line 7431 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1109; /* fmindf3 */

            case E_V4HFmode:
              if (pattern77 (x3, 
E_V4HFmode) != 0
                  || !(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2689; /* fminv4hf3 */

            case E_V8HFmode:
              if (pattern124 (x3, 
E_V8HFmode, 
E_V8HFmode) != 0
                  || !(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2695; /* fminv8hf3 */

            case E_V2SFmode:
              if (pattern77 (x3, 
E_V2SFmode) != 0
                  || !
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2705; /* fminv2sf3 */

            case E_V4SFmode:
              if (pattern77 (x3, 
E_V4SFmode) != 0
                  || !
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2711; /* fminv4sf3 */

            case E_V2DFmode:
              if (pattern77 (x3, 
E_V2DFmode) != 0
                  || !
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2715; /* fminv2df3 */

            case E_VNx16BFmode:
              if (pattern78 (x3, 
E_VNx16BFmode) != 0
                  || !(
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12296; /* *aarch64_sve_fminnmvnx16bf */

            case E_VNx32BFmode:
              if (pattern78 (x3, 
E_VNx32BFmode) != 0
                  || !(
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12300; /* *aarch64_sve_fminnmvnx32bf */

            case E_VNx16HFmode:
              if (pattern78 (x3, 
E_VNx16HFmode) != 0
                  || !
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12304; /* *aarch64_sve_fminnmvnx16hf */

            case E_VNx8SFmode:
              if (pattern78 (x3, 
E_VNx8SFmode) != 0
                  || !
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12308; /* *aarch64_sve_fminnmvnx8sf */

            case E_VNx4DFmode:
              if (pattern78 (x3, 
E_VNx4DFmode) != 0
                  || !
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12312; /* *aarch64_sve_fminnmvnx4df */

            case E_VNx32HFmode:
              if (pattern78 (x3, 
E_VNx32HFmode) != 0
                  || !
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12316; /* *aarch64_sve_fminnmvnx32hf */

            case E_VNx16SFmode:
              if (pattern78 (x3, 
E_VNx16SFmode) != 0
                  || !
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12320; /* *aarch64_sve_fminnmvnx16sf */

            case E_VNx8DFmode:
              if (pattern78 (x3, 
E_VNx8DFmode) != 0
                  || !
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12324; /* *aarch64_sve_fminnmvnx8df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern80 (x3))
            {
            case 0:
              if (!(
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12328; /* aarch64_sve_single_fminnmvnx16bf */

            case 1:
              if (!(
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12332; /* aarch64_sve_single_fminnmvnx32bf */

            case 2:
              if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12336; /* aarch64_sve_single_fminnmvnx16hf */

            case 3:
              if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12340; /* aarch64_sve_single_fminnmvnx8sf */

            case 4:
              if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12344; /* aarch64_sve_single_fminnmvnx4df */

            case 5:
              if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12348; /* aarch64_sve_single_fminnmvnx32hf */

            case 6:
              if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12352; /* aarch64_sve_single_fminnmvnx16sf */

            case 7:
              if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12356; /* aarch64_sve_single_fminnmvnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 277)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          x5 = XVECEXP (x3, 0, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1058 (x3, 
E_VNx8BFmode) != 0
                  || !
#line 491 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))
                return -1;
              return 11859; /* aarch64_sve_fclampvnx8bf */

            case E_VNx8HFmode:
              if (pattern1058 (x3, 
E_VNx8HFmode) != 0
                  || !
#line 492 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 11860; /* aarch64_sve_fclampvnx8hf */

            case E_VNx4SFmode:
              if (pattern1058 (x3, 
E_VNx4SFmode) != 0
                  || !
#line 493 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 11861; /* aarch64_sve_fclampvnx4sf */

            case E_VNx2DFmode:
              if (pattern1058 (x3, 
E_VNx2DFmode) != 0
                  || !
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 11862; /* aarch64_sve_fclampvnx2df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != VEC_DUPLICATE)
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BFmode:
              if (pattern1118 (x3, 
E_VNx8BFmode, 
E_VNx16BFmode) != 0
                  || !(
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 11867; /* aarch64_sve_fclamp_singlevnx16bf */

            case E_VNx32BFmode:
              if (pattern1118 (x3, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0
                  || !(
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 11868; /* aarch64_sve_fclamp_singlevnx32bf */

            case E_VNx16HFmode:
              if (pattern1118 (x3, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11869; /* aarch64_sve_fclamp_singlevnx16hf */

            case E_VNx8SFmode:
              if (pattern1118 (x3, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11870; /* aarch64_sve_fclamp_singlevnx8sf */

            case E_VNx4DFmode:
              if (pattern1118 (x3, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11871; /* aarch64_sve_fclamp_singlevnx4df */

            case E_VNx32HFmode:
              if (pattern1118 (x3, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11872; /* aarch64_sve_fclamp_singlevnx32hf */

            case E_VNx16SFmode:
              if (pattern1118 (x3, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11873; /* aarch64_sve_fclamp_singlevnx16sf */

            case E_VNx8DFmode:
              if (pattern1118 (x3, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0
                  || !
#line 1422 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11874; /* aarch64_sve_fclamp_singlevnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4856; /* aarch64_uzp1v8qi */

    case 1:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4866; /* aarch64_uzp1v16qi */

    case 2:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4880; /* aarch64_uzp1v4hi */

    case 3:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4890; /* aarch64_uzp1v8hi */

    case 4:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4904; /* aarch64_uzp1v2si */

    case 5:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4914; /* aarch64_uzp1v4si */

    case 6:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4920; /* aarch64_uzp1v2di */

    case 7:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4934; /* aarch64_uzp1v4hf */

    case 8:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4944; /* aarch64_uzp1v8hf */

    case 9:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4958; /* aarch64_uzp1v4bf */

    case 10:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4968; /* aarch64_uzp1v8bf */

    case 11:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4982; /* aarch64_uzp1v2sf */

    case 12:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4992; /* aarch64_uzp1v4sf */

    case 13:
      if (!
#line 8634 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4998; /* aarch64_uzp1v2df */

    case 14:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10535; /* aarch64_sve_uzp1vnx16qi */

    case 15:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10545; /* aarch64_sve_uzp1vnx8qi */

    case 16:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10555; /* aarch64_sve_uzp1vnx4qi */

    case 17:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10565; /* aarch64_sve_uzp1vnx2qi */

    case 18:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10575; /* aarch64_sve_uzp1vnx8hi */

    case 19:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10585; /* aarch64_sve_uzp1vnx4hi */

    case 20:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10595; /* aarch64_sve_uzp1vnx2hi */

    case 21:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10605; /* aarch64_sve_uzp1vnx4si */

    case 22:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10615; /* aarch64_sve_uzp1vnx2si */

    case 23:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10625; /* aarch64_sve_uzp1vnx2di */

    case 24:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10635; /* aarch64_sve_uzp1vnx8hf */

    case 25:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10645; /* aarch64_sve_uzp1vnx4hf */

    case 26:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10655; /* aarch64_sve_uzp1vnx2hf */

    case 27:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10665; /* aarch64_sve_uzp1vnx8bf */

    case 28:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10675; /* aarch64_sve_uzp1vnx4bf */

    case 29:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10685; /* aarch64_sve_uzp1vnx2bf */

    case 30:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10695; /* aarch64_sve_uzp1vnx4sf */

    case 31:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10705; /* aarch64_sve_uzp1vnx2sf */

    case 32:
      if (!
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10715; /* aarch64_sve_uzp1vnx2df */

    case 33:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10796; /* aarch64_sve_uzp1vnx16bi */

    case 34:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10802; /* aarch64_sve_uzp1vnx8bi */

    case 35:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10808; /* aarch64_sve_uzp1vnx4bi */

    case 36:
      if (!
#line 9284 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10814; /* aarch64_sve_uzp1vnx2bi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (8 / 8), 0, 15)))
        return -1;
      return 12834; /* aarch64_sve_dupqvnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12835; /* aarch64_sve_dupqvnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (32 / 8), 0, 15)))
        return -1;
      return 12836; /* aarch64_sve_dupqvnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (64 / 8), 0, 15)))
        return -1;
      return 12837; /* aarch64_sve_dupqvnx2di */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !register_operand (operands[1], E_VNx8BFmode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12838; /* aarch64_sve_dupqvnx8bf */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12839; /* aarch64_sve_dupqvnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (32 / 8), 0, 15)))
        return -1;
      return 12840; /* aarch64_sve_dupqvnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 3804 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (64 / 8), 0, 15)))
        return -1;
      return 12841; /* aarch64_sve_dupqvnx2df */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!(
#line 7431 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1100; /* fmaxhf3 */

    case 1:
      if (!
#line 7431 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1104; /* fmaxsf3 */

    case 2:
      if (!
#line 7431 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1108; /* fmaxdf3 */

    case 3:
      if (!(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2686; /* fmaxv4hf3 */

    case 4:
      if (!(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2694; /* fmaxv8hf3 */

    case 5:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2702; /* fmaxv2sf3 */

    case 6:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2710; /* fmaxv4sf3 */

    case 7:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2714; /* fmaxv2df3 */

    case 8:
      if (!(
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12294; /* *aarch64_sve_fmaxnmvnx16bf */

    case 9:
      if (!(
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12298; /* *aarch64_sve_fmaxnmvnx32bf */

    case 10:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12302; /* *aarch64_sve_fmaxnmvnx16hf */

    case 11:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12306; /* *aarch64_sve_fmaxnmvnx8sf */

    case 12:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12310; /* *aarch64_sve_fmaxnmvnx4df */

    case 13:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12314; /* *aarch64_sve_fmaxnmvnx32hf */

    case 14:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12318; /* *aarch64_sve_fmaxnmvnx16sf */

    case 15:
      if (!
#line 2515 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12322; /* *aarch64_sve_fmaxnmvnx8df */

    case 16:
      if (!(
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12326; /* aarch64_sve_single_fmaxnmvnx16bf */

    case 17:
      if (!(
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12330; /* aarch64_sve_single_fmaxnmvnx32bf */

    case 18:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12334; /* aarch64_sve_single_fmaxnmvnx16hf */

    case 19:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12338; /* aarch64_sve_single_fmaxnmvnx8sf */

    case 20:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12342; /* aarch64_sve_single_fmaxnmvnx4df */

    case 21:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12346; /* aarch64_sve_single_fmaxnmvnx32hf */

    case 22:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12350; /* aarch64_sve_single_fmaxnmvnx16sf */

    case 23:
      if (!
#line 2526 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12354; /* aarch64_sve_single_fmaxnmvnx8df */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern121 (x1))
    {
    case 0:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10538; /* aarch64_sve_uzpq2vnx16qi */

    case 1:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10548; /* aarch64_sve_uzpq2vnx8qi */

    case 2:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10558; /* aarch64_sve_uzpq2vnx4qi */

    case 3:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10568; /* aarch64_sve_uzpq2vnx2qi */

    case 4:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10578; /* aarch64_sve_uzpq2vnx8hi */

    case 5:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10588; /* aarch64_sve_uzpq2vnx4hi */

    case 6:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10598; /* aarch64_sve_uzpq2vnx2hi */

    case 7:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10608; /* aarch64_sve_uzpq2vnx4si */

    case 8:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10618; /* aarch64_sve_uzpq2vnx2si */

    case 9:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10628; /* aarch64_sve_uzpq2vnx2di */

    case 10:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10638; /* aarch64_sve_uzpq2vnx8hf */

    case 11:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10648; /* aarch64_sve_uzpq2vnx4hf */

    case 12:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10658; /* aarch64_sve_uzpq2vnx2hf */

    case 13:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10668; /* aarch64_sve_uzpq2vnx8bf */

    case 14:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10678; /* aarch64_sve_uzpq2vnx4bf */

    case 15:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10688; /* aarch64_sve_uzpq2vnx2bf */

    case 16:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10698; /* aarch64_sve_uzpq2vnx4sf */

    case 17:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10708; /* aarch64_sve_uzpq2vnx2sf */

    case 18:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10718; /* aarch64_sve_uzpq2vnx2df */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern725 (x3, 
E_V16QImode, 
E_VNx16BImode, 
E_VNx16QImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6455; /* aarch64_sve_ld1rqvnx16qi */

    case E_VNx8HImode:
      if (pattern725 (x3, 
E_V8HImode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6456; /* aarch64_sve_ld1rqvnx8hi */

    case E_VNx4SImode:
      if (pattern725 (x3, 
E_V4SImode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6457; /* aarch64_sve_ld1rqvnx4si */

    case E_VNx2DImode:
      if (pattern725 (x3, 
E_V2DImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6458; /* aarch64_sve_ld1rqvnx2di */

    case E_VNx8BFmode:
      if (pattern725 (x3, 
E_V8BFmode, 
E_VNx8BImode, 
E_VNx8BFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6459; /* aarch64_sve_ld1rqvnx8bf */

    case E_VNx8HFmode:
      if (pattern725 (x3, 
E_V8HFmode, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6460; /* aarch64_sve_ld1rqvnx8hf */

    case E_VNx4SFmode:
      if (pattern725 (x3, 
E_V4SFmode, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6461; /* aarch64_sve_ld1rqvnx4sf */

    case E_VNx2DFmode:
      if (pattern725 (x3, 
E_V2DFmode, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
          || !
#line 2804 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6462; /* aarch64_sve_ld1rqvnx2df */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern91 (x1))
    {
    case 0:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2129; /* aarch64_sminpv8qi */

    case 1:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2135; /* aarch64_sminpv16qi */

    case 2:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2145; /* aarch64_sminpv4hi */

    case 3:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2151; /* aarch64_sminpv8hi */

    case 4:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2161; /* aarch64_sminpv2si */

    case 5:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2167; /* aarch64_sminpv4si */

    case 6:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10414; /* aarch64_pred_reduc_smin_vnx16qi */

    case 7:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10421; /* aarch64_pred_reduc_smin_vnx8hi */

    case 8:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10428; /* aarch64_pred_reduc_smin_vnx4si */

    case 9:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10435; /* aarch64_pred_reduc_smin_vnx2di */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12890; /* aarch64_sve_zipqvnx32qi */

    case 1:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12892; /* aarch64_sve_zipqvnx16hi */

    case 2:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12894; /* aarch64_sve_zipqvnx8si */

    case 3:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12896; /* aarch64_sve_zipqvnx4di */

    case 4:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12898; /* aarch64_sve_zipqvnx16bf */

    case 5:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12900; /* aarch64_sve_zipqvnx16hf */

    case 6:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12902; /* aarch64_sve_zipqvnx8sf */

    case 7:
      if (!
#line 3885 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12904; /* aarch64_sve_zipqvnx4df */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern730 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10473; /* aarch64_sve_compactvnx4si */

    case E_VNx2DImode:
      if (pattern730 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10474; /* aarch64_sve_compactvnx2di */

    case E_VNx4SFmode:
      if (pattern730 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10475; /* aarch64_sve_compactvnx4sf */

    case E_VNx2DFmode:
      if (pattern730 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 9113 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10476; /* aarch64_sve_compactvnx2df */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      return 1042; /* ucvtfsi3 */

    case 1:
      return 1044; /* ucvtfdi3 */

    case 2:
      if (!
#line 7226 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1050; /* ucvtfsihf3 */

    case 3:
      if (!
#line 7226 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1052; /* ucvtfdihf3 */

    case 4:
      if (!
#line 7246 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1056; /* ucvtfhi3 */

    case 5:
      if (!(
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 291 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2643; /* ucvtfv4hi3 */

    case 6:
      if (!(
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 292 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2645; /* ucvtfv8hi3 */

    case 7:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2647; /* ucvtfv2si3 */

    case 8:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2649; /* ucvtfv4si3 */

    case 9:
      if (!
#line 3136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2651; /* ucvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || pattern85 (x1, 
E_V8DImode, 
94) != 0
      || !aarch64_sync_memory_operand (operands[0], E_V8DImode)
      || !
#line 560 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME2))
    return -1;
  return 13032; /* aarch64_restore_zt0 */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern128 (x1))
    {
    case 0:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12132; /* aarch64_sve_smulltvnx8hi */

    case 1:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12153; /* aarch64_sve_smulltvnx4si */

    case 2:
      if (!
#line 2270 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12174; /* aarch64_sve_smulltvnx2di */

    case 3:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12190; /* aarch64_sve_smullt_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12196; /* aarch64_sve_smullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12777; /* aarch64_pred_reduc_umaxqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12785; /* aarch64_pred_reduc_umaxqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12793; /* aarch64_pred_reduc_umaxqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12801; /* aarch64_pred_reduc_umaxqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12549; /* aarch64_sve_cadd90vnx16qi */

    case 1:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12553; /* aarch64_sve_cadd90vnx8hi */

    case 2:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12557; /* aarch64_sve_cadd90vnx4si */

    case 3:
      if (!
#line 2984 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12561; /* aarch64_sve_cadd90vnx2di */

    default:
      return -1;
    }
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (XWINT (x4, 0) == 0L)
    {
      x5 = XVECEXP (x3, 0, 2);
      x6 = XVECEXP (x5, 0, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x5, 0, 0);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1274 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) == 0
                  && 
#line 6354 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8997; /* *aarch64_cond_abdvnx8hf_3_relaxed */
              break;

            case E_VNx4SFmode:
              if (pattern1274 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) == 0
                  && 
#line 6354 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8998; /* *aarch64_cond_abdvnx4sf_3_relaxed */
              break;

            case E_VNx2DFmode:
              if (pattern1274 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) == 0
                  && 
#line 6354 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 8999; /* *aarch64_cond_abdvnx2df_3_relaxed */
              break;

            default:
              break;
            }
        }
    }
  operands[4] = x4;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern1274 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9000; /* *aarch64_cond_abdvnx8hf_3_strict */

    case E_VNx4SFmode:
      if (pattern1274 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9001; /* *aarch64_cond_abdvnx4sf_3_strict */

    case E_VNx2DFmode:
      if (pattern1274 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9002; /* *aarch64_cond_abdvnx2df_3_strict */

    default:
      return -1;
    }
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern872 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7237; /* *cond_btruncvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7303; /* *cond_btruncvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7248; /* *cond_btruncvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7314; /* *cond_btruncvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7259; /* *cond_btruncvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7325; /* *cond_btruncvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7270; /* *cond_btruncvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7336; /* *cond_btruncvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7281; /* *cond_btruncvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7347; /* *cond_btruncvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7292; /* *cond_btruncvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7358; /* *cond_btruncvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11827; /* *cond_sqshlvnx8hi_2 */
    }
  if (register_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11835; /* *cond_sqshlvnx8hi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1294 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11843; /* *cond_sqshlvnx8hi_any */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11675; /* *cond_uqrshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11722; /* *cond_uqrshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11762; /* *cond_uqrshlvnx16qi_any */
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11695; /* *cond_srshlvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11739; /* *cond_srshlvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11779; /* *cond_srshlvnx4si_any */
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11669; /* *cond_sqrshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11717; /* *cond_sqrshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11757; /* *cond_sqrshlvnx16qi_any */
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1061 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8541; /* *cond_sminvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8687; /* *cond_sminvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8791; /* *cond_sminvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8554; /* *cond_sminvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8700; /* *cond_sminvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8804; /* *cond_sminvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8567; /* *cond_sminvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8713; /* *cond_sminvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8817; /* *cond_sminvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8580; /* *cond_sminvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8726; /* *cond_sminvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8830; /* *cond_sminvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8639; /* *cond_sminvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8889; /* *cond_sminvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8646; /* *cond_sminvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8896; /* *cond_sminvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8653; /* *cond_sminvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8903; /* *cond_sminvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8593; /* *cond_sminvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8739; /* *cond_sminvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8843; /* *cond_sminvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8606; /* *cond_sminvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8752; /* *cond_sminvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8856; /* *cond_sminvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8619; /* *cond_sminvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8765; /* *cond_sminvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8869; /* *cond_sminvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8632; /* *cond_sminvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8778; /* *cond_sminvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8882; /* *cond_sminvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8660; /* *cond_sminvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8910; /* *cond_sminvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8667; /* *cond_sminvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8917; /* *cond_sminvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8674; /* *cond_sminvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8924; /* *cond_sminvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1060 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8538; /* *cond_mulxvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8684; /* *cond_mulxvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8788; /* *cond_mulxvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8551; /* *cond_mulxvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8697; /* *cond_mulxvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8801; /* *cond_mulxvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8564; /* *cond_mulxvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8710; /* *cond_mulxvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8814; /* *cond_mulxvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8577; /* *cond_mulxvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8723; /* *cond_mulxvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8827; /* *cond_mulxvnx2df_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8590; /* *cond_mulxvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8736; /* *cond_mulxvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8840; /* *cond_mulxvnx8bf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8603; /* *cond_mulxvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8749; /* *cond_mulxvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8853; /* *cond_mulxvnx8hf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8616; /* *cond_mulxvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8762; /* *cond_mulxvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8866; /* *cond_mulxvnx4sf_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8629; /* *cond_mulxvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8775; /* *cond_mulxvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8879; /* *cond_mulxvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx16QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6436; /* sve_ld1rvnx16qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx16QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9462; /* aarch64_sel_dupvnx16qi */

    case E_VNx8QImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6437; /* sve_ld1rvnx8qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9463; /* aarch64_sel_dupvnx8qi */

    case E_VNx4QImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6438; /* sve_ld1rvnx4qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9464; /* aarch64_sel_dupvnx4qi */

    case E_VNx2QImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_QImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2QImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6439; /* sve_ld1rvnx2qi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9465; /* aarch64_sel_dupvnx2qi */

    case E_VNx8HImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8HImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6440; /* sve_ld1rvnx8hi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9466; /* aarch64_sel_dupvnx8hi */

    case E_VNx4HImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4HImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6441; /* sve_ld1rvnx4hi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9467; /* aarch64_sel_dupvnx4hi */

    case E_VNx2HImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2HImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6442; /* sve_ld1rvnx2hi */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9468; /* aarch64_sel_dupvnx2hi */

    case E_VNx4SImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4SImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6443; /* sve_ld1rvnx4si */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9469; /* aarch64_sel_dupvnx4si */

    case E_VNx2SImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2SImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6444; /* sve_ld1rvnx2si */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9470; /* aarch64_sel_dupvnx2si */

    case E_VNx2DImode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_DImode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2DImode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6445; /* sve_ld1rvnx2di */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2DImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9471; /* aarch64_sel_dupvnx2di */

    case E_VNx8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8HFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6446; /* sve_ld1rvnx8hf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9472; /* aarch64_sel_dupvnx8hf */

    case E_VNx4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx4HFmode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4HFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6447; /* sve_ld1rvnx4hf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9473; /* aarch64_sel_dupvnx4hf */

    case E_VNx2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2HFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_HFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2HFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6448; /* sve_ld1rvnx2hf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9474; /* aarch64_sel_dupvnx2hf */

    case E_VNx8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_BFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx8BFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6449; /* sve_ld1rvnx8bf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_BFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx8BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9475; /* aarch64_sel_dupvnx8bf */

    case E_VNx4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx4BFmode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_BFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4BFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6450; /* sve_ld1rvnx4bf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_BFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9476; /* aarch64_sel_dupvnx4bf */

    case E_VNx2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2BFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_BFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2BFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6451; /* sve_ld1rvnx2bf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_BFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9477; /* aarch64_sel_dupvnx2bf */

    case E_VNx4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx4SFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6452; /* sve_ld1rvnx4sf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx4SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9478; /* aarch64_sel_dupvnx4sf */

    case E_VNx2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2SFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_SFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2SFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6453; /* sve_ld1rvnx2sf */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9479; /* aarch64_sel_dupvnx2sf */

    case E_VNx2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern733 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (aarch64_sve_ld1r_operand (operands[2], E_DFmode))
        {
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (aarch64_simd_imm_zero (operands[3], E_VNx2DFmode)
              && 
#line 2792 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 6454; /* sve_ld1rvnx2df */
        }
      operands[3] = x3;
      operands[1] = x5;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!aarch64_simd_reg_or_zero (operands[2], E_VNx2DFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9480; /* aarch64_sel_dupvnx2df */

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern734 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7489; /* *cond_sssubvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7659; /* *cond_sssubvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7829; /* *cond_sssubvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7506; /* *cond_sssubvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7676; /* *cond_sssubvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7846; /* *cond_sssubvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7523; /* *cond_sssubvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7693; /* *cond_sssubvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7863; /* *cond_sssubvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7540; /* *cond_sssubvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7710; /* *cond_sssubvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7880; /* *cond_sssubvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7557; /* *cond_sssubvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7727; /* *cond_sssubvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7897; /* *cond_sssubvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7574; /* *cond_sssubvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7744; /* *cond_sssubvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7914; /* *cond_sssubvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7591; /* *cond_sssubvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7761; /* *cond_sssubvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7931; /* *cond_sssubvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7608; /* *cond_sssubvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7778; /* *cond_sssubvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7948; /* *cond_sssubvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7625; /* *cond_sssubvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7795; /* *cond_sssubvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7965; /* *cond_sssubvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7642; /* *cond_sssubvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7812; /* *cond_sssubvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7982; /* *cond_sssubvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern734 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7476; /* *cond_mulvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7646; /* *cond_mulvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7816; /* *cond_mulvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7493; /* *cond_mulvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7663; /* *cond_mulvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7833; /* *cond_mulvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7510; /* *cond_mulvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7680; /* *cond_mulvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7850; /* *cond_mulvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7527; /* *cond_mulvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7697; /* *cond_mulvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7867; /* *cond_mulvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7544; /* *cond_mulvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7714; /* *cond_mulvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7884; /* *cond_mulvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7561; /* *cond_mulvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7731; /* *cond_mulvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7901; /* *cond_mulvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7578; /* *cond_mulvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7748; /* *cond_mulvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7918; /* *cond_mulvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7595; /* *cond_mulvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7765; /* *cond_mulvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7935; /* *cond_mulvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7612; /* *cond_mulvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7782; /* *cond_mulvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7952; /* *cond_mulvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7629; /* *cond_mulvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7799; /* *cond_mulvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7969; /* *cond_mulvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !register_operand (operands[2], E_V2x8QImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4417; /* aarch64_vec_load_lanesv2x8qi_lanev8qi */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !register_operand (operands[2], E_V2x4HImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4418; /* aarch64_vec_load_lanesv2x4hi_lanev4hi */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !register_operand (operands[2], E_V2x2SImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4419; /* aarch64_vec_load_lanesv2x2si_lanev2si */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !register_operand (operands[2], E_V2x1DImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4420; /* aarch64_vec_load_lanesv2x1di_lanedi */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !register_operand (operands[2], E_V2x4HFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4421; /* aarch64_vec_load_lanesv2x4hf_lanev4hf */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !register_operand (operands[2], E_V2x2SFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4422; /* aarch64_vec_load_lanesv2x2sf_lanev2sf */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !register_operand (operands[2], E_V2x1DFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4423; /* aarch64_vec_load_lanesv2x1df_lanedf */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !register_operand (operands[2], E_V2x4BFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4424; /* aarch64_vec_load_lanesv2x4bf_lanev4bf */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode)
          || GET_MODE (x3) != E_V2x16QImode
          || !register_operand (operands[2], E_V2x16QImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4425; /* aarch64_vec_load_lanesv2x16qi_lanev16qi */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode)
          || GET_MODE (x3) != E_V2x8HImode
          || !register_operand (operands[2], E_V2x8HImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4426; /* aarch64_vec_load_lanesv2x8hi_lanev8hi */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode)
          || GET_MODE (x3) != E_V2x4SImode
          || !register_operand (operands[2], E_V2x4SImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4427; /* aarch64_vec_load_lanesv2x4si_lanev4si */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode)
          || GET_MODE (x3) != E_V2x2DImode
          || !register_operand (operands[2], E_V2x2DImode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4428; /* aarch64_vec_load_lanesv2x2di_lanev2di */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode)
          || GET_MODE (x3) != E_V2x8HFmode
          || !register_operand (operands[2], E_V2x8HFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4429; /* aarch64_vec_load_lanesv2x8hf_lanev8hf */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode)
          || GET_MODE (x3) != E_V2x4SFmode
          || !register_operand (operands[2], E_V2x4SFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4430; /* aarch64_vec_load_lanesv2x4sf_lanev4sf */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode)
          || GET_MODE (x3) != E_V2x2DFmode
          || !register_operand (operands[2], E_V2x2DFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4431; /* aarch64_vec_load_lanesv2x2df_lanev2df */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode)
          || GET_MODE (x3) != E_V2x8BFmode
          || !register_operand (operands[2], E_V2x8BFmode)
          || !
#line 7584 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4432; /* aarch64_vec_load_lanesv2x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern800 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5738; /* maskloadvnx16qivnx16bi */

    case E_VNx8QImode:
      if (pattern800 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5739; /* maskloadvnx8qivnx8bi */

    case E_VNx4QImode:
      if (pattern800 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5740; /* maskloadvnx4qivnx4bi */

    case E_VNx2QImode:
      if (pattern800 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5741; /* maskloadvnx2qivnx2bi */

    case E_VNx8HImode:
      if (pattern800 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5742; /* maskloadvnx8hivnx8bi */

    case E_VNx4HImode:
      if (pattern800 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5743; /* maskloadvnx4hivnx4bi */

    case E_VNx2HImode:
      if (pattern800 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5744; /* maskloadvnx2hivnx2bi */

    case E_VNx4SImode:
      if (pattern800 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5745; /* maskloadvnx4sivnx4bi */

    case E_VNx2SImode:
      if (pattern800 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5746; /* maskloadvnx2sivnx2bi */

    case E_VNx2DImode:
      if (pattern800 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5747; /* maskloadvnx2divnx2bi */

    case E_VNx8HFmode:
      if (pattern800 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5748; /* maskloadvnx8hfvnx8bi */

    case E_VNx4HFmode:
      if (pattern800 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5749; /* maskloadvnx4hfvnx4bi */

    case E_VNx2HFmode:
      if (pattern800 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5750; /* maskloadvnx2hfvnx2bi */

    case E_VNx8BFmode:
      if (pattern800 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5751; /* maskloadvnx8bfvnx8bi */

    case E_VNx4BFmode:
      if (pattern800 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5752; /* maskloadvnx4bfvnx4bi */

    case E_VNx2BFmode:
      if (pattern800 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5753; /* maskloadvnx2bfvnx2bi */

    case E_VNx4SFmode:
      if (pattern800 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5754; /* maskloadvnx4sfvnx4bi */

    case E_VNx2SFmode:
      if (pattern800 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5755; /* maskloadvnx2sfvnx2bi */

    case E_VNx2DFmode:
      if (pattern800 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5756; /* maskloadvnx2dfvnx2bi */

    default:
      return -1;
    }
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9980; /* while_wrsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9990; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10000; /* while_wrsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10010; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10020; /* while_wrsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10030; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10040; /* while_wrsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10050; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9972; /* while_ultsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9982; /* while_ultdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9992; /* while_ultsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10002; /* while_ultdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10012; /* while_ultsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10022; /* while_ultdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10032; /* while_ultsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10042; /* while_ultdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern188 (x1))
    {
    case 0:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11311; /* aarch64_st1vnx32qi */

    case 1:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11313; /* aarch64_st1vnx16hi */

    case 2:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11315; /* aarch64_st1vnx8si */

    case 3:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11317; /* aarch64_st1vnx4di */

    case 4:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11319; /* aarch64_st1vnx16bf */

    case 5:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11321; /* aarch64_st1vnx16hf */

    case 6:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11323; /* aarch64_st1vnx8sf */

    case 7:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11325; /* aarch64_st1vnx4df */

    case 8:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11327; /* aarch64_st1vnx64qi */

    case 9:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11329; /* aarch64_st1vnx32hi */

    case 10:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11331; /* aarch64_st1vnx16si */

    case 11:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11333; /* aarch64_st1vnx8di */

    case 12:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11335; /* aarch64_st1vnx32bf */

    case 13:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11337; /* aarch64_st1vnx32hf */

    case 14:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11339; /* aarch64_st1vnx16sf */

    case 15:
      if (!
#line 480 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11341; /* aarch64_st1vnx8df */

    default:
      return -1;
    }
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1065 (x2))
        {
        case 0:
          if (!
#line 914 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13329; /* aarch64_sme_readvnx4di */

        case 1:
          if (!
#line 914 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13330; /* aarch64_sme_readvnx8di */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_SImode))
        return -1;
      switch (pattern1065 (x2))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13331; /* *aarch64_sme_readvnx4di_plus */

        case 1:
          if (!
#line 926 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13332; /* *aarch64_sme_readvnx8di_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern805 (x3, 
E_VNx16QImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12059; /* aarch64_sve_srivnx16qi */

    case E_VNx8HImode:
      if (pattern805 (x3, 
E_VNx8HImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12061; /* aarch64_sve_srivnx8hi */

    case E_VNx4SImode:
      if (pattern805 (x3, 
E_VNx4SImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12063; /* aarch64_sve_srivnx4si */

    case E_VNx2DImode:
      if (pattern805 (x3, 
E_VNx2DImode) != 0
          || !
#line 2003 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12065; /* aarch64_sve_srivnx2di */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (pattern881 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12671; /* aarch64_pred_flogbvnx8hf */

    case E_VNx4SImode:
      if (pattern881 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12672; /* aarch64_pred_flogbvnx4sf */

    case E_VNx2DImode:
      if (pattern881 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 3530 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12673; /* aarch64_pred_flogbvnx2df */

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12567; /* aarch64_sve_cmla180vnx16qi */

    case 1:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12575; /* aarch64_sve_cmla180vnx8hi */

    case 2:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12583; /* aarch64_sve_cmla180vnx4si */

    case 3:
      if (!
#line 3016 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12591; /* aarch64_sve_cmla180vnx2di */

    case 4:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12599; /* aarch64_cmla180_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12607; /* aarch64_cmla180_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12616; /* aarch64_sve_cdot270vnx4si */

    case 1:
      if (!
#line 3096 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12620; /* aarch64_sve_cdot270vnx2di */

    case 2:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12624; /* aarch64_cdot270_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12628; /* aarch64_cdot270_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12497; /* aarch64_pred_smaxpvnx16qi */

    case 1:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12502; /* aarch64_pred_smaxpvnx8hi */

    case 2:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12507; /* aarch64_pred_smaxpvnx4si */

    case 3:
      if (!
#line 2821 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12512; /* aarch64_pred_smaxpvnx2di */

    default:
      return -1;
    }
}

 int
recog_384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern189 (x1, 
E_DImode))
    {
    case 0:
      if (!
#line 677 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11444; /* aarch64_sve_cntp_c8 */

    case 1:
      if (!
#line 677 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11445; /* aarch64_sve_cntp_c16 */

    case 2:
      if (!
#line 677 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11446; /* aarch64_sve_cntp_c32 */

    case 3:
      if (!
#line 677 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11447; /* aarch64_sve_cntp_c64 */

    default:
      return -1;
    }
}

 int
recog_392 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10139; /* while_rwsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10149; /* while_rwdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10159; /* while_rwsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10169; /* while_rwdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10179; /* while_rwsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10189; /* while_rwdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10199; /* while_rwsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10209; /* while_rwdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern223 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[1] = x4;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[0], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11408; /* aarch64_scatter_stntvnx4si */

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11410; /* aarch64_scatter_stntvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[0], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11409; /* aarch64_scatter_stntvnx2di */

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode)
                  || !
#line 557 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11411; /* aarch64_scatter_stntvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          switch (pattern1175 (x6, 
E_VNx4SImode, 
E_VNx4BImode))
            {
            case 0:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
                return -1;
              return 11412; /* aarch64_scatter_stnt_vnx4sivnx8qi */

            case 1:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
                return -1;
              return 11413; /* aarch64_scatter_stnt_vnx4sivnx4qi */

            case 2:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
                return -1;
              return 11414; /* aarch64_scatter_stnt_vnx4sivnx2qi */

            case 3:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
                return -1;
              return 11415; /* aarch64_scatter_stnt_vnx4sivnx4hi */

            case 4:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
                return -1;
              return 11416; /* aarch64_scatter_stnt_vnx4sivnx2hi */

            case 5:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
                return -1;
              return 11417; /* aarch64_scatter_stnt_vnx4sivnx2si */

            default:
              return -1;
            }

        case E_VNx2BImode:
          switch (pattern1175 (x6, 
E_VNx2DImode, 
E_VNx2BImode))
            {
            case 0:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
                return -1;
              return 11418; /* aarch64_scatter_stnt_vnx2divnx8qi */

            case 1:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
                return -1;
              return 11419; /* aarch64_scatter_stnt_vnx2divnx4qi */

            case 2:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
                return -1;
              return 11420; /* aarch64_scatter_stnt_vnx2divnx2qi */

            case 3:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
                return -1;
              return 11421; /* aarch64_scatter_stnt_vnx2divnx4hi */

            case 4:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
                return -1;
              return 11422; /* aarch64_scatter_stnt_vnx2divnx2hi */

            case 5:
              if (!
#line 574 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
                return -1;
              return 11423; /* aarch64_scatter_stnt_vnx2divnx2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern222 (x1))
    {
    case 0:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11343; /* aarch64_st1vnx32qi_strided2 */

    case 1:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11345; /* aarch64_st1vnx16hi_strided2 */

    case 2:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11347; /* aarch64_st1vnx8si_strided2 */

    case 3:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11349; /* aarch64_st1vnx4di_strided2 */

    case 4:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11351; /* aarch64_st1vnx16bf_strided2 */

    case 5:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11353; /* aarch64_st1vnx16hf_strided2 */

    case 6:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11355; /* aarch64_st1vnx8sf_strided2 */

    case 7:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11357; /* aarch64_st1vnx4df_strided2 */

    case 8:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11359; /* aarch64_st1vnx64qi_strided2 */

    case 9:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11361; /* aarch64_st1vnx32hi_strided2 */

    case 10:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11363; /* aarch64_st1vnx16si_strided2 */

    case 11:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11365; /* aarch64_st1vnx8di_strided2 */

    case 12:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11367; /* aarch64_st1vnx32bf_strided2 */

    case 13:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11369; /* aarch64_st1vnx32hf_strided2 */

    case 14:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11371; /* aarch64_st1vnx16sf_strided2 */

    case 15:
      if (!
#line 493 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11373; /* aarch64_st1vnx8df_strided2 */

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern208 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8520; /* aarch64_pred_mulxvnx8hf */

    case E_VNx4SFmode:
      if (pattern208 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8524; /* aarch64_pred_mulxvnx4sf */

    case E_VNx2DFmode:
      if (pattern208 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8528; /* aarch64_pred_mulxvnx2df */

    case E_VNx8BFmode:
      if (pattern208 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && false))
        return -1;
      return 11855; /* aarch64_pred_mulxvnx8bf */

    default:
      return -1;
    }
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern254 (x1))
    {
    case 0:
      if (!
#line 1429 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13739; /* aarch64_sme_smlavnx4sivnx16qi */

    case 1:
      if (!
#line 1429 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13743; /* aarch64_sme_smlavnx4sivnx8hi */

    case 2:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13755; /* aarch64_sme_smlavnx4sivnx32qi */

    case 3:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13759; /* aarch64_sme_smlavnx4sivnx64qi */

    case 4:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13763; /* aarch64_sme_smlavnx4sivnx16hi */

    case 5:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13767; /* aarch64_sme_smlavnx4sivnx32hi */

    case 6:
      if (!
#line 1557 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13867; /* aarch64_sme_smlavnx2divnx8hi */

    case 7:
      if (!
#line 1587 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13875; /* aarch64_sme_smlavnx2divnx16hi */

    case 8:
      if (!
#line 1587 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13879; /* aarch64_sme_smlavnx2divnx32hi */

    case 9:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13787; /* aarch64_sme_single_smlavnx4sivnx32qi */

    case 10:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13791; /* aarch64_sme_single_smlavnx4sivnx64qi */

    case 11:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13795; /* aarch64_sme_single_smlavnx4sivnx16hi */

    case 12:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13799; /* aarch64_sme_single_smlavnx4sivnx32hi */

    case 13:
      if (!
#line 1618 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13891; /* aarch64_sme_single_smlavnx2divnx16hi */

    case 14:
      if (!
#line 1618 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13895; /* aarch64_sme_single_smlavnx2divnx32hi */

    case 15:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13819; /* aarch64_sme_lane_smlavnx4sivnx16qi */

    case 16:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13823; /* aarch64_sme_lane_smlavnx4sivnx32qi */

    case 17:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13827; /* aarch64_sme_lane_smlavnx4sivnx64qi */

    case 18:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13831; /* aarch64_sme_lane_smlavnx4sivnx8hi */

    case 19:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13835; /* aarch64_sme_lane_smlavnx4sivnx16hi */

    case 20:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13839; /* aarch64_sme_lane_smlavnx4sivnx32hi */

    case 21:
      if (!
#line 1652 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13907; /* aarch64_sme_lane_smlavnx2divnx8hi */

    case 22:
      if (!
#line 1652 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13911; /* aarch64_sme_lane_smlavnx2divnx16hi */

    case 23:
      if (!
#line 1652 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13915; /* aarch64_sme_lane_smlavnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1443 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13747; /* *aarch64_sme_smlavnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1443 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13751; /* *aarch64_sme_smlavnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1325 ())
            {
            case 0:
              if (
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13771; /* *aarch64_sme_smlavnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13775; /* *aarch64_sme_smlavnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13779; /* *aarch64_sme_smlavnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13783; /* *aarch64_sme_smlavnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1571 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13871; /* *aarch64_sme_smlavnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13883; /* *aarch64_sme_smlavnx2divnx16hi_plus */

        case 1:
          if (!
#line 1601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13887; /* *aarch64_sme_smlavnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1327 (x3))
            {
            case 0:
              if (
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13803; /* *aarch64_sme_single_smlavnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13807; /* *aarch64_sme_single_smlavnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13811; /* *aarch64_sme_single_smlavnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13815; /* *aarch64_sme_single_smlavnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1633 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13899; /* *aarch64_sme_single_smlavnx2divnx16hi_plus */

    case 28:
      if (!
#line 1633 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13903; /* *aarch64_sme_single_smlavnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13843; /* *aarch64_sme_lane_smlavnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1365 (x3))
                {
                case 0:
                  if (
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13847; /* *aarch64_sme_lane_smlavnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13851; /* *aarch64_sme_lane_smlavnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13855; /* *aarch64_sme_lane_smlavnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1366 (x3))
        {
        case 0:
          if (!
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13859; /* *aarch64_sme_lane_smlavnx4sivnx16hi */

        case 1:
          if (!
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13863; /* *aarch64_sme_lane_smlavnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1669 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13919; /* *aarch64_sme_lane_smlavnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1366 (x3))
        {
        case 0:
          if (!
#line 1669 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13923; /* *aarch64_sme_lane_smlavnx2divnx16hi */

        case 1:
          if (!
#line 1669 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13927; /* *aarch64_sme_lane_smlavnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern110 (x2, 
E_VNx4SImode, 
93) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != 168)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93
      || GET_MODE (x5) != E_VNx4SImode)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (!const_int_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 3);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 0);
      operands[2] = x9;
      operands[3] = x6;
      switch (pattern1344 (x4))
        {
        case 0:
          if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13970; /* aarch64_sme_lane_fvdotvnx4sivnx16bf */

        case 1:
          if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13972; /* aarch64_sme_lane_fvdotvnx4sivnx32bf */

        case 2:
          if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13974; /* aarch64_sme_lane_fvdotvnx4sivnx16hf */

        case 3:
          if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13976; /* aarch64_sme_lane_fvdotvnx4sivnx32hf */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[1] = x11;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 3);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 0);
      operands[3] = x9;
      operands[4] = x6;
      switch (pattern1357 (x4))
        {
        case 0:
          if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13978; /* *aarch64_sme_lane_fvdotvnx4sivnx16bf_plus */

        case 1:
          if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13980; /* *aarch64_sme_lane_fvdotvnx4sivnx32bf_plus */

        case 2:
          if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13982; /* *aarch64_sme_lane_fvdotvnx4sivnx16hf_plus */

        case 3:
          if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13984; /* *aarch64_sme_lane_fvdotvnx4sivnx32hf_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_441 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern252 (x1))
    {
    case 0:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13618; /* aarch64_sme_lane_usvdotvnx4sivnx32qi */

    case 1:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13626; /* aarch64_sme_lane_usvdotvnx4sivnx64qi */

    case 2:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13634; /* aarch64_sme_lane_usvdotvnx4sivnx16hi */

    case 3:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13642; /* aarch64_sme_lane_usvdotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13650; /* aarch64_sme_lane_usvdotvnx2divnx32qi */

    case 5:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13658; /* aarch64_sme_lane_usvdotvnx2divnx64qi */

    case 6:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13666; /* aarch64_sme_lane_usvdotvnx2divnx16hi */

    case 7:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13674; /* aarch64_sme_lane_usvdotvnx2divnx32hi */

    case 8:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13682; /* *aarch64_sme_lane_usvdotvnx4sivnx32qi_plus */

    case 9:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
        return -1;
      return 13690; /* *aarch64_sme_lane_usvdotvnx4sivnx64qi_plus */

    case 10:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13698; /* *aarch64_sme_lane_usvdotvnx4sivnx16hi_plus */

    case 11:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
        return -1;
      return 13706; /* *aarch64_sme_lane_usvdotvnx4sivnx32hi_plus */

    case 12:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13714; /* *aarch64_sme_lane_usvdotvnx2divnx32qi_plus */

    case 13:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13722; /* *aarch64_sme_lane_usvdotvnx2divnx64qi_plus */

    case 14:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13730; /* *aarch64_sme_lane_usvdotvnx2divnx16hi_plus */

    case 15:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13738; /* *aarch64_sme_lane_usvdotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 162:
      if (pattern53 (x1, 
84) != 0
          || !aarch64_reg_or_zero (operands[0], E_DImode)
          || !
#line 1920 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP8))
        return -1;
      return 84; /* aarch64_write_fpmr */

    case 82:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 6114 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 761; /* *aarch64_sisd_neg_qi */

    case 36:
      return recog_52 (x1, insn, pnum_clobbers);

    case 34:
      return recog_40 (x1, insn, pnum_clobbers);

    case 32:
      return recog_39 (x1, insn, pnum_clobbers);

    case 33:
      return recog_38 (x1, insn, pnum_clobbers);

    case 31:
      return recog_51 (x1, insn, pnum_clobbers);

    case 35:
      return recog_50 (x1, insn, pnum_clobbers);

    case 30:
      return recog_37 (x1, insn, pnum_clobbers);

    case 39:
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LO_SUM)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern865 (x2, 
E_SImode) != 0
              || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1127; /* ldr_got_small_28k_si */

        case E_DImode:
          if (pattern865 (x2, 
E_DImode) != 0
              || !
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1128; /* ldr_got_small_28k_di */

        default:
          return -1;
        }

    case 41:
      return recog_49 (x1, insn, pnum_clobbers);

    case 97:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1133; /* aarch64_load_tp_hard */

    case 40:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
        return -1;
      switch (pattern42 (x2))
        {
        case 0:
          if (!
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1136; /* tlsie_small_si */

        case 1:
          if (!
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1137; /* tlsie_small_di */

        default:
          return -1;
        }

    case 101:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1146; /* tlsle32_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1147; /* tlsle32_di */

        default:
          return -1;
        }

    case 102:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1148; /* tlsle48_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1149; /* tlsle48_di */

        default:
          return -1;
        }

    case 21:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 7889 "../../gcc/config/aarch64/aarch64.md"
(TARGET_JSCVT))
        return -1;
      *pnum_clobbers = 1;
      return 1155; /* aarch64_fjcvtzs */

    case 114:
      if (pattern44 (x1, 
30, 
E_DImode) != 0)
        return -1;
      return 1164; /* xpaclri */

    case 107:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      switch (pattern42 (x2))
        {
        case 0:
          if (!(
#line 8021 "../../gcc/config/aarch64/aarch64.md"
(aarch64_stack_protector_guard != SSP_GLOBAL) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
            return -1;
          return 1169; /* reg_stack_protect_address_si */

        case 1:
          if (!(
#line 8021 "../../gcc/config/aarch64/aarch64.md"
(aarch64_stack_protector_guard != SSP_GLOBAL) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
            return -1;
          return 1170; /* reg_stack_protect_address_di */

        default:
          return -1;
        }

    case 22:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1200; /* aarch64_frint32zv2sf */

        case 1:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1204; /* aarch64_frint32zv4sf */

        case 2:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1208; /* aarch64_frint32zv2df */

        case 3:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1212; /* aarch64_frint32zdf */

        case 4:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1216; /* aarch64_frint32zsf */

        default:
          return -1;
        }

    case 23:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1201; /* aarch64_frint32xv2sf */

        case 1:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1205; /* aarch64_frint32xv4sf */

        case 2:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1209; /* aarch64_frint32xv2df */

        case 3:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1213; /* aarch64_frint32xdf */

        case 4:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1217; /* aarch64_frint32xsf */

        default:
          return -1;
        }

    case 24:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1202; /* aarch64_frint64zv2sf */

        case 1:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1206; /* aarch64_frint64zv4sf */

        case 2:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1210; /* aarch64_frint64zv2df */

        case 3:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1214; /* aarch64_frint64zdf */

        case 4:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1218; /* aarch64_frint64zsf */

        default:
          return -1;
        }

    case 25:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1203; /* aarch64_frint64xv2sf */

        case 1:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1207; /* aarch64_frint64xv4sf */

        case 2:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1211; /* aarch64_frint64xv2df */

        case 3:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1215; /* aarch64_frint64xdf */

        case 4:
          if (!
#line 8311 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1219; /* aarch64_frint64xsf */

        default:
          return -1;
        }

    case 179:
      if (pattern58 (x2, 
E_CCmode, 
66, 
E_DImode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1237; /* aarch64_save_nzcv */

    case 180:
      if (pattern41 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1238; /* aarch64_restore_nzcv */

    case 111:
      return recog_16 (x1, insn, pnum_clobbers);

    case 187:
      return recog_28 (x1, insn, pnum_clobbers);

    case 203:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 2691 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2405; /* aarch64_fnegv2di2 */

    case 588:
      return recog_48 (x1, insn, pnum_clobbers);

    case 205:
      return recog_15 (x1, insn, pnum_clobbers);

    case 202:
      return recog_47 (x1, insn, pnum_clobbers);

    case 208:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2846; /* aarch64_reduc_umax_internalv8qi */

        case 1:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2850; /* aarch64_reduc_umax_internalv16qi */

        case 2:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2854; /* aarch64_reduc_umax_internalv4hi */

        case 3:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2858; /* aarch64_reduc_umax_internalv8hi */

        case 4:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2862; /* aarch64_reduc_umax_internalv4si */

        case 5:
          if (!
#line 3687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2866; /* aarch64_reduc_umax_internalv2si */

        default:
          return -1;
        }

    case 209:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2847; /* aarch64_reduc_umin_internalv8qi */

        case 1:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2851; /* aarch64_reduc_umin_internalv16qi */

        case 2:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2855; /* aarch64_reduc_umin_internalv4hi */

        case 3:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2859; /* aarch64_reduc_umin_internalv8hi */

        case 4:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2863; /* aarch64_reduc_umin_internalv4si */

        case 5:
          if (!
#line 3687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2867; /* aarch64_reduc_umin_internalv2si */

        default:
          return -1;
        }

    case 206:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2848; /* aarch64_reduc_smax_internalv8qi */

        case 1:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2852; /* aarch64_reduc_smax_internalv16qi */

        case 2:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2856; /* aarch64_reduc_smax_internalv4hi */

        case 3:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2860; /* aarch64_reduc_smax_internalv8hi */

        case 4:
          if (!
#line 3678 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2864; /* aarch64_reduc_smax_internalv4si */

        case 5:
          if (!
#line 3687 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2868; /* aarch64_reduc_smax_internalv2si */

        default:
          return -1;
        }

    case 207:
      return recog_57 (x1, insn, pnum_clobbers);

    case 198:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2870; /* aarch64_reduc_smax_nan_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2874; /* aarch64_reduc_smax_nan_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2878; /* aarch64_reduc_smax_nan_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2882; /* aarch64_reduc_smax_nan_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2886; /* aarch64_reduc_smax_nan_internalv2df */

        default:
          return -1;
        }

    case 201:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2871; /* aarch64_reduc_smin_nan_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2875; /* aarch64_reduc_smin_nan_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2879; /* aarch64_reduc_smin_nan_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2883; /* aarch64_reduc_smin_nan_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2887; /* aarch64_reduc_smin_nan_internalv2df */

        default:
          return -1;
        }

    case 197:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2872; /* aarch64_reduc_smax_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2876; /* aarch64_reduc_smax_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2880; /* aarch64_reduc_smax_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2884; /* aarch64_reduc_smax_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2888; /* aarch64_reduc_smax_internalv2df */

        default:
          return -1;
        }

    case 200:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2873; /* aarch64_reduc_smin_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2877; /* aarch64_reduc_smin_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2881; /* aarch64_reduc_smin_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2885; /* aarch64_reduc_smin_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2889; /* aarch64_reduc_smin_internalv2df */

        default:
          return -1;
        }

    case 51:
      return recog_27 (x1, insn, pnum_clobbers);

    case 53:
      return recog_19 (x1, insn, pnum_clobbers);

    case 91:
      return recog_14 (x1, insn, pnum_clobbers);

    case 54:
      return recog_26 (x1, insn, pnum_clobbers);

    case 56:
      return recog_18 (x1, insn, pnum_clobbers);

    case 92:
      return recog_13 (x1, insn, pnum_clobbers);

    case 57:
      return recog_25 (x1, insn, pnum_clobbers);

    case 59:
      return recog_17 (x1, insn, pnum_clobbers);

    case 93:
      return recog_12 (x1, insn, pnum_clobbers);

    case 46:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      return recog_9 (x1, insn, pnum_clobbers);

    case 86:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      return recog_10 (x1, insn, pnum_clobbers);

    case 52:
      return recog_24 (x1, insn, pnum_clobbers);

    case 55:
      return recog_23 (x1, insn, pnum_clobbers);

    case 58:
      return recog_22 (x1, insn, pnum_clobbers);

    case 254:
      return recog_33 (x1, insn, pnum_clobbers);

    case 255:
      return recog_31 (x1, insn, pnum_clobbers);

    case 256:
      return recog_32 (x1, insn, pnum_clobbers);

    case 27:
      return recog_20 (x1, insn, pnum_clobbers);

    case 29:
      return recog_36 (x1, insn, pnum_clobbers);

    case 26:
      return recog_46 (x1, insn, pnum_clobbers);

    case 257:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 8922 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5175; /* aarch64_crypto_aesev16qi */

        case 1:
          if (!
#line 4147 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12979; /* aarch64_sve2_aese */

        default:
          return -1;
        }

    case 258:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 8922 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5176; /* aarch64_crypto_aesdv16qi */

        case 1:
          if (!
#line 4147 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12980; /* aarch64_sve2_aesd */

        default:
          return -1;
        }

    case 259:
      switch (pattern65 (x1, 
257))
        {
        case 0:
          if (!
#line 8931 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5177; /* aarch64_crypto_aesmcv16qi */

        case 1:
          if (!
#line 4158 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12981; /* aarch64_sve2_aesmc */

        case 2:
          if (!
#line 8950 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES
   && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 5179; /* *aarch64_crypto_aese_fused */

        case 3:
          if (!
#line 4177 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 12983; /* *aarch64_sve2_aese_fused */

        default:
          return -1;
        }

    case 260:
      switch (pattern65 (x1, 
258))
        {
        case 0:
          if (!
#line 8931 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5178; /* aarch64_crypto_aesimcv16qi */

        case 1:
          if (!
#line 4158 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12982; /* aarch64_sve2_aesimc */

        case 2:
          if (!
#line 8971 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES
   && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 5180; /* *aarch64_crypto_aesd_fused */

        case 3:
          if (!
#line 4192 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 12984; /* *aarch64_sve2_aesd_fused */

        default:
          return -1;
        }

    case 264:
      return recog_35 (x1, insn, pnum_clobbers);

    case 585:
      return recog_30 (x1, insn, pnum_clobbers);

    case 587:
      return recog_45 (x1, insn, pnum_clobbers);

    case 586:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8BFmode)
          || !
#line 10014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5279; /* aarch64_vbfcvt_highv8bf */

    case 153:
      return recog_21 (x1, insn, pnum_clobbers);

    case 159:
      if (pattern44 (x1, 
86, 
E_VNx16BImode) != 0
          || !
#line 1257 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5737; /* aarch64_update_ffrt */

    case 325:
      return recog_34 (x1, insn, pnum_clobbers);

    case 77:
      return recog_11 (x1, insn, pnum_clobbers);

    case 129:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10834; /* aarch64_sve_sunpkhi_vnx16qi */

        case 1:
          if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10838; /* aarch64_sve_sunpkhi_vnx8hi */

        case 2:
          if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10842; /* aarch64_sve_sunpkhi_vnx4si */

        default:
          return -1;
        }

    case 130:
      return recog_56 (x1, insn, pnum_clobbers);

    case 131:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10836; /* aarch64_sve_sunpklo_vnx16qi */

        case 1:
          if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10840; /* aarch64_sve_sunpklo_vnx8hi */

        case 2:
          if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10844; /* aarch64_sve_sunpklo_vnx4si */

        default:
          return -1;
        }

    case 132:
      return recog_55 (x1, insn, pnum_clobbers);

    case 613:
      return recog_29 (x1, insn, pnum_clobbers);

    case 611:
      return recog_54 (x1, insn, pnum_clobbers);

    case 482:
      return recog_53 (x1, insn, pnum_clobbers);

    case 528:
      switch (pattern70 (x1))
        {
        case 0:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12367; /* aarch64_sve_sqxtnbvnx8hi */

        case 1:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12370; /* aarch64_sve_sqxtnbvnx4si */

        case 2:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12373; /* aarch64_sve_sqxtnbvnx2di */

        default:
          return -1;
        }

    case 530:
      switch (pattern70 (x1))
        {
        case 0:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12368; /* aarch64_sve_sqxtunbvnx8hi */

        case 1:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12371; /* aarch64_sve_sqxtunbvnx4si */

        case 2:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12374; /* aarch64_sve_sqxtunbvnx2di */

        default:
          return -1;
        }

    case 565:
      switch (pattern70 (x1))
        {
        case 0:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12369; /* aarch64_sve_uqxtnbvnx8hi */

        case 1:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12372; /* aarch64_sve_uqxtnbvnx4si */

        case 2:
          if (!
#line 2627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12375; /* aarch64_sve_uqxtnbvnx2di */

        default:
          return -1;
        }

    case 617:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2657 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12385; /* aarch64_sve_sqcvtvnx16qivnx16si */

        case 1:
          if (!
#line 3727 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12391; /* aarch64_sve_sqcvtvnx8hivnx8si */

        case 2:
          if (!
#line 2675 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12397; /* aarch64_sve_sqcvtvnx8hivnx8di */

        default:
          return -1;
        }

    case 618:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 2657 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3728 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12386; /* aarch64_sve_sqcvtnvnx16qivnx16si */

        case 1:
          if (!
#line 3728 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12392; /* aarch64_sve_sqcvtnvnx8hivnx8si */

        case 2:
          if (!(
#line 2675 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3728 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12398; /* aarch64_sve_sqcvtnvnx8hivnx8di */

        default:
          return -1;
        }

    case 619:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2657 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12387; /* aarch64_sve_sqcvtuvnx16qivnx16si */

        case 1:
          if (!
#line 3729 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12393; /* aarch64_sve_sqcvtuvnx8hivnx8si */

        case 2:
          if (!
#line 2675 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12399; /* aarch64_sve_sqcvtuvnx8hivnx8di */

        default:
          return -1;
        }

    case 620:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 2657 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3730 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12388; /* aarch64_sve_sqcvtunvnx16qivnx16si */

        case 1:
          if (!
#line 3730 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12394; /* aarch64_sve_sqcvtunvnx8hivnx8si */

        case 2:
          if (!(
#line 2675 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3730 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12400; /* aarch64_sve_sqcvtunvnx8hivnx8di */

        default:
          return -1;
        }

    case 626:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2657 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12389; /* aarch64_sve_uqcvtvnx16qivnx16si */

        case 1:
          if (!
#line 3731 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12395; /* aarch64_sve_uqcvtvnx8hivnx8si */

        case 2:
          if (!
#line 2675 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12401; /* aarch64_sve_uqcvtvnx8hivnx8di */

        default:
          return -1;
        }

    case 627:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 2657 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3732 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12390; /* aarch64_sve_uqcvtnvnx16qivnx16si */

        case 1:
          if (!
#line 3732 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12396; /* aarch64_sve_uqcvtnvnx8hivnx8si */

        case 2:
          if (!(
#line 2675 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3732 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12402; /* aarch64_sve_uqcvtnvnx8hivnx8di */

        default:
          return -1;
        }

    case 604:
      if (GET_MODE (x2) != E_VNx8SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!aligned_register_operand (operands[0], E_VNx8SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3348 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME_F16F16))
        return -1;
      return 12650; /* aarch64_sve_cvtlvnx8sf */

    case 605:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      switch (pattern135 (x2))
        {
        case 0:
          if (!
#line 3377 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12653; /* aarch64_sve_cvtnvnx8bf */

        case 1:
          if (!
#line 3377 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12654; /* aarch64_sve_cvtnvnx8hf */

        default:
          return -1;
        }

    case 576:
      return recog_44 (x1, insn, pnum_clobbers);

    case 574:
      return recog_43 (x1, insn, pnum_clobbers);

    case 577:
      return recog_42 (x1, insn, pnum_clobbers);

    case 575:
      return recog_41 (x1, insn, pnum_clobbers);

    case 683:
      if (pattern44 (x1, 
67, 
E_DImode) != 0)
        return -1;
      return 12989; /* aarch64_update_vg */

    case 694:
      if (pattern53 (x1, 
88) != 0
          || !memory_operand (operands[0], E_V16QImode))
        return -1;
      return 12998; /* aarch64_setup_local_tpidr2 */

    case 696:
      if (pattern44 (x1, 
87, 
E_DImode) != 0)
        return -1;
      return 13006; /* aarch64_start_private_za_call */

    case 697:
      if (pattern44 (x1, 
87, 
E_DImode) != 0)
        return -1;
      return 13007; /* aarch64_end_private_za_call */

    default:
      return -1;
    }
}

 int
recog_465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (aarch64_comparison_operation (operands[2], E_VOIDmode))
    {
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode))
            return 473; /* *csinc2si_insn */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode))
            return 474; /* *csinc2di_insn */
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x3) != EQ)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      x4 = XEXP (x2, 1);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern955 (x2, 
E_V8QImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4211; /* aarch64_cmtstv8qi */

        case E_V16QImode:
          if (pattern955 (x2, 
E_V16QImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4214; /* aarch64_cmtstv16qi */

        case E_V4HImode:
          if (pattern955 (x2, 
E_V4HImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4215; /* aarch64_cmtstv4hi */

        case E_V8HImode:
          if (pattern955 (x2, 
E_V8HImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4218; /* aarch64_cmtstv8hi */

        case E_V2SImode:
          if (pattern955 (x2, 
E_V2SImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4219; /* aarch64_cmtstv2si */

        case E_V4SImode:
          if (pattern955 (x2, 
E_V4SImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4222; /* aarch64_cmtstv4si */

        case E_V2DImode:
          if (pattern955 (x2, 
E_V2DImode) != 0
              || !
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4223; /* aarch64_cmtstv2di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern894 (x2, 
E_V8QImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4224; /* *aarch64_cmtst_same_v8qi */

        case E_V16QImode:
          if (pattern894 (x2, 
E_V16QImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4227; /* *aarch64_cmtst_same_v16qi */

        case E_V4HImode:
          if (pattern894 (x2, 
E_V4HImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4228; /* *aarch64_cmtst_same_v4hi */

        case E_V8HImode:
          if (pattern894 (x2, 
E_V8HImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4231; /* *aarch64_cmtst_same_v8hi */

        case E_V2SImode:
          if (pattern894 (x2, 
E_V2SImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4232; /* *aarch64_cmtst_same_v2si */

        case E_V4SImode:
          if (pattern894 (x2, 
E_V4SImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4235; /* *aarch64_cmtst_same_v4si */

        case E_V2DImode:
          if (pattern894 (x2, 
E_V2DImode) != 0
              || !
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4236; /* *aarch64_cmtst_same_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) == 0)
            return 377; /* mulsi3 */
          break;

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) == 0)
            return 378; /* muldi3 */
          break;

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) == 0
              && (
#line 7280 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return 1063; /* mulhf3 */
          break;

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) == 0
              && 
#line 7280 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1064; /* mulsf3 */
          break;

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) == 0
              && 
#line 7280 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1065; /* muldf3 */
          break;

        case E_V8QImode:
          if (pattern31 (x2, 
E_V8QImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1379; /* mulv8qi3 */
          break;

        case E_V16QImode:
          if (pattern31 (x2, 
E_V16QImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1382; /* mulv16qi3 */
          break;

        case E_V4HImode:
          if (pattern31 (x2, 
E_V4HImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1383; /* mulv4hi3 */
          break;

        case E_V8HImode:
          if (pattern31 (x2, 
E_V8HImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1386; /* mulv8hi3 */
          break;

        case E_V2SImode:
          if (pattern31 (x2, 
E_V2SImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1387; /* mulv2si3 */
          break;

        case E_V4SImode:
          if (pattern31 (x2, 
E_V4SImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1390; /* mulv4si3 */
          break;

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) == 0
              && (
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2378; /* mulv4hf3 */
          break;

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) == 0
              && (
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2381; /* mulv8hf3 */
          break;

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) == 0
              && 
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2382; /* mulv2sf3 */
          break;

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) == 0
              && 
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2385; /* mulv4sf3 */
          break;

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) == 0
              && 
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2386; /* mulv2df3 */
          break;

        case E_VNx8BFmode:
          if (pattern31 (x2, 
E_VNx8BFmode) == 0
              && (
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8501; /* *post_ra_fmulvnx8bf3 */
          break;

        case E_VNx8HFmode:
          if (pattern31 (x2, 
E_VNx8HFmode) == 0
              && 
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8504; /* *post_ra_fmulvnx8hf3 */
          break;

        case E_VNx4SFmode:
          if (pattern31 (x2, 
E_VNx4SFmode) == 0
              && 
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8507; /* *post_ra_fmulvnx4sf3 */
          break;

        case E_VNx2DFmode:
          if (pattern31 (x2, 
E_VNx2DFmode) == 0
              && 
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8510; /* *post_ra_fmulvnx2df3 */
          break;

        default:
          break;
        }
      break;

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern313 (x2, 
E_VNx16QImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7419; /* *post_ra_mulvnx16qi3 */
          break;

        case E_VNx8QImode:
          if (pattern313 (x2, 
E_VNx8QImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7424; /* *post_ra_mulvnx8qi3 */
          break;

        case E_VNx4QImode:
          if (pattern313 (x2, 
E_VNx4QImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7429; /* *post_ra_mulvnx4qi3 */
          break;

        case E_VNx2QImode:
          if (pattern313 (x2, 
E_VNx2QImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7434; /* *post_ra_mulvnx2qi3 */
          break;

        case E_VNx8HImode:
          if (pattern313 (x2, 
E_VNx8HImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7439; /* *post_ra_mulvnx8hi3 */
          break;

        case E_VNx4HImode:
          if (pattern313 (x2, 
E_VNx4HImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7444; /* *post_ra_mulvnx4hi3 */
          break;

        case E_VNx2HImode:
          if (pattern313 (x2, 
E_VNx2HImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7449; /* *post_ra_mulvnx2hi3 */
          break;

        case E_VNx4SImode:
          if (pattern313 (x2, 
E_VNx4SImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7454; /* *post_ra_mulvnx4si3 */
          break;

        case E_VNx2SImode:
          if (pattern313 (x2, 
E_VNx2SImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7459; /* *post_ra_mulvnx2si3 */
          break;

        case E_VNx2DImode:
          if (pattern313 (x2, 
E_VNx2DImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7464; /* *post_ra_mulvnx2di3 */
          break;

        case E_V2DImode:
          if (pattern313 (x2, 
E_V2DImode) == 0
              && 
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7469; /* *post_ra_mulv2di3 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern652 (x2, 
E_VNx16QImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11612; /* *aarch64_mul_unpredicated_vnx16qi */

    case E_VNx8QImode:
      if (pattern652 (x2, 
E_VNx8QImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11613; /* *aarch64_mul_unpredicated_vnx8qi */

    case E_VNx4QImode:
      if (pattern652 (x2, 
E_VNx4QImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11614; /* *aarch64_mul_unpredicated_vnx4qi */

    case E_VNx2QImode:
      if (pattern652 (x2, 
E_VNx2QImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11615; /* *aarch64_mul_unpredicated_vnx2qi */

    case E_VNx8HImode:
      if (pattern652 (x2, 
E_VNx8HImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11616; /* *aarch64_mul_unpredicated_vnx8hi */

    case E_VNx4HImode:
      if (pattern652 (x2, 
E_VNx4HImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11617; /* *aarch64_mul_unpredicated_vnx4hi */

    case E_VNx2HImode:
      if (pattern652 (x2, 
E_VNx2HImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11618; /* *aarch64_mul_unpredicated_vnx2hi */

    case E_VNx4SImode:
      if (pattern652 (x2, 
E_VNx4SImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11619; /* *aarch64_mul_unpredicated_vnx4si */

    case E_VNx2SImode:
      if (pattern652 (x2, 
E_VNx2SImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11620; /* *aarch64_mul_unpredicated_vnx2si */

    case E_VNx2DImode:
      if (pattern652 (x2, 
E_VNx2DImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11621; /* *aarch64_mul_unpredicated_vnx2di */

    case E_V2DImode:
      if (pattern652 (x2, 
E_V2DImode) != 0
          || !
#line 859 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11622; /* *aarch64_mul_unpredicated_v2di */

    default:
      return -1;
    }
}

 int
recog_477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 2);
  operands[1] = x6;
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !const_int_operand (operands[1], E_SImode)
          || !const_int_operand (operands[2], E_SImode)
          || !
#line 1663 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[1]) < GET_MODE_BITSIZE (SImode)
   && UINTVAL (operands[1]) % 16 == 0))
        return -1;
      return 71; /* insv_immsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !const_int_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode)
          || !
#line 1663 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[1]) < GET_MODE_BITSIZE (DImode)
   && UINTVAL (operands[1]) % 16 == 0))
        return -1;
      return 72; /* insv_immdi */

    default:
      return -1;
    }
}

 int
recog_479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern817 (x2))
                {
                case 0:
                  if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3082; /* *aarch64_shaddv8qi_insn */

                case 1:
                  if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3094; /* *aarch64_shaddv16qi_insn */

                case 2:
                  if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3098; /* *aarch64_shaddv4hi_insn */

                case 3:
                  if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3110; /* *aarch64_shaddv8hi_insn */

                case 4:
                  if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3114; /* *aarch64_shaddv2si_insn */

                case 5:
                  if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3126; /* *aarch64_shaddv4si_insn */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_VECTOR:
              switch (pattern756 (x2))
                {
                case 0:
                  if (pattern1015 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3794; /* aarch64_srshr_nv8qi_insn */

                case 1:
                  if (pattern1015 (x2, 
E_V16QImode, 
E_V16HImode) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3800; /* aarch64_srshr_nv16qi_insn */

                case 2:
                  if (pattern1016 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3802; /* aarch64_srshr_nv4hi_insn */

                case 3:
                  if (pattern1016 (x2, 
E_V8HImode, 
E_V8SImode) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3808; /* aarch64_srshr_nv8hi_insn */

                case 4:
                  if (pattern1017 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3810; /* aarch64_srshr_nv2si_insn */

                case 5:
                  if (pattern1017 (x2, 
E_V4SImode, 
E_V4DImode) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3816; /* aarch64_srshr_nv4si_insn */

                case 6:
                  if (pattern1018 (x2) != 0
                      || !
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3818; /* aarch64_srshr_nv2di_insn */

                case 7:
                  if (!
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3820; /* aarch64_srshr_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          switch (pattern817 (x2))
            {
            case 0:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3088; /* *aarch64_uhaddv8qi_insn */

            case 1:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3096; /* *aarch64_uhaddv16qi_insn */

            case 2:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3104; /* *aarch64_uhaddv4hi_insn */

            case 3:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3112; /* *aarch64_uhaddv8hi_insn */

            case 4:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3120; /* *aarch64_uhaddv2si_insn */

            case 5:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3128; /* *aarch64_uhaddv4si_insn */

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern819 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3130; /* *aarch64_srhaddv8qi_insn */

                case 1:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3136; /* *aarch64_srhaddv16qi_insn */

                case 2:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3138; /* *aarch64_srhaddv4hi_insn */

                case 3:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3144; /* *aarch64_srhaddv8hi_insn */

                case 4:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3146; /* *aarch64_srhaddv2si_insn */

                case 5:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3152; /* *aarch64_srhaddv4si_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern819 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3133; /* *aarch64_urhaddv8qi_insn */

                case 1:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3137; /* *aarch64_urhaddv16qi_insn */

                case 2:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3141; /* *aarch64_urhaddv4hi_insn */

                case 3:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3145; /* *aarch64_urhaddv8hi_insn */

                case 4:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3149; /* *aarch64_urhaddv2si_insn */

                case 5:
                  if (!
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3153; /* *aarch64_urhaddv4si_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              switch (pattern904 (x2))
                {
                case 0:
                  if (!
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3172; /* aarch64_raddhnv8hi_insn */

                case 1:
                  if (!
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3178; /* aarch64_raddhnv4si_insn */

                case 2:
                  if (!
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3184; /* aarch64_raddhnv2di_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern964 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3154; /* aarch64_addhnv8hi_insn */

            case E_V4HImode:
              if (pattern964 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3160; /* aarch64_addhnv4si_insn */

            case E_V2SImode:
              if (pattern964 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3166; /* aarch64_addhnv2di_insn */

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          switch (pattern904 (x2))
            {
            case 0:
              if (!
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3175; /* aarch64_rsubhnv8hi_insn */

            case 1:
              if (!
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3181; /* aarch64_rsubhnv4si_insn */

            case 2:
              if (!
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3187; /* aarch64_rsubhnv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern759 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3085; /* *aarch64_shsubv8qi_insn */

            case 1:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3095; /* *aarch64_shsubv16qi_insn */

            case 2:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3101; /* *aarch64_shsubv4hi_insn */

            case 3:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3111; /* *aarch64_shsubv8hi_insn */

            case 4:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3117; /* *aarch64_shsubv2si_insn */

            case 5:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3127; /* *aarch64_shsubv4si_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern759 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3091; /* *aarch64_uhsubv8qi_insn */

            case 1:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3097; /* *aarch64_uhsubv16qi_insn */

            case 2:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3107; /* *aarch64_uhsubv4hi_insn */

            case 3:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3113; /* *aarch64_uhsubv8hi_insn */

            case 4:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3123; /* *aarch64_uhsubv2si_insn */

            case 5:
              if (!
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3129; /* *aarch64_uhsubv4si_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern964 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3157; /* aarch64_subhnv8hi_insn */

            case E_V4HImode:
              if (pattern964 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3163; /* aarch64_subhnv4si_insn */

            case E_V2SImode:
              if (pattern964 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3169; /* aarch64_subhnv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern345 (x2))
        {
        case 0:
          if (!
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3911; /* *aarch64_sshrn_nv8hi_insn */

        case 1:
          if (!
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3929; /* *aarch64_sshrn_nv4si_insn */

        case 2:
          if (!
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3947; /* *aarch64_sshrn_nv2di_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern424 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1355; /* addv8qi3_vec_concatz_be */

        case E_V8HImode:
          if (pattern424 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1359; /* addv4hi3_vec_concatz_be */

        case E_V4SImode:
          if (pattern424 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1363; /* addv2si3_vec_concatz_be */

        case E_V8HFmode:
          if (pattern424 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2362; /* addv4hf3_vec_concatz_be */

        case E_V4SFmode:
          if (pattern424 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2366; /* addv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1420; /* aarch64_fcmla0v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1436; /* aarch64_fcmla0v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 408:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1423; /* aarch64_fcmla90v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1439; /* aarch64_fcmla90v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 409:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1426; /* aarch64_fcmla180v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1442; /* aarch64_fcmla180v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 410:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1429; /* aarch64_fcmla270v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1445; /* aarch64_fcmla270v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 279:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1512; /* sdot_prodv2siv8qi_vec_concatz_be */

            case 280:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1515; /* udot_prodv2siv8qi_vec_concatz_be */

            case 573:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                return -1;
              return 1520; /* usdot_prodv2siv8qi_vec_concatz_be */

            default:
              return -1;
            }

        case 3:
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x7 = XVECEXP (x4, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1456; /* aarch64_fcmla_lane0v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1492; /* aarch64_fcmla_laneq0v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1472; /* aarch64_fcmla_lane0v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 408:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1459; /* aarch64_fcmla_lane90v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1495; /* aarch64_fcmla_laneq90v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1475; /* aarch64_fcmla_lane90v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 409:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1462; /* aarch64_fcmla_lane180v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1498; /* aarch64_fcmla_laneq180v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1478; /* aarch64_fcmla_lane180v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 410:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1465; /* aarch64_fcmla_lane270v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1501; /* aarch64_fcmla_laneq270v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1481; /* aarch64_fcmla_lane270v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 279:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1524; /* aarch64_sdot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1532; /* aarch64_sdot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 280:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1527; /* aarch64_udot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1535; /* aarch64_udot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 573:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1540; /* aarch64_usdot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1548; /* aarch64_usdot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 578:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1543; /* aarch64_sudot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1551; /* aarch64_sudot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != VEC_SELECT)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x5 = XEXP (x2, 0);
      operands[5] = x5;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      x13 = XEXP (x11, 1);
      operands[4] = x13;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x14 = XEXP (x10, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTEND:
          switch (pattern1082 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1703; /* *aarch64_sadalpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1711; /* *aarch64_sadalpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1721; /* *aarch64_sadalpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1082 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1706; /* *aarch64_uadalpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1714; /* *aarch64_uadalpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1724; /* *aarch64_uadalpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 0);
      operands[4] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SMAX:
          switch (pattern832 (x2, 
SMIN))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1727; /* aarch64_sabav8qi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1735; /* aarch64_sabav4hi_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1743; /* aarch64_sabav2si_vec_concatz_be */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern832 (x2, 
UMIN))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1730; /* aarch64_uabav8qi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1738; /* aarch64_uabav4hi_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1746; /* aarch64_uabav2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1019 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2002; /* aarch64_mlav8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1019 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2006; /* aarch64_mlav4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1019 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2010; /* aarch64_mlav2si_vec_concatz_be */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x14 = XEXP (x10, 0);
          switch (GET_CODE (x14))
            {
            case VEC_SELECT:
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x5 = XEXP (x2, 0);
              operands[5] = x5;
              x16 = XEXP (x14, 0);
              operands[1] = x16;
              x17 = XVECEXP (x15, 0, 0);
              operands[2] = x17;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x4, 1);
              operands[3] = x11;
              x6 = XEXP (x3, 1);
              operands[4] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1238 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[1], E_V4HImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1651 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2014; /* *aarch64_mla_eltv4hi_vec_concatz_be */

                    case E_V8HImode:
                      if (!register_operand (operands[1], E_V8HImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1669 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2022; /* *aarch64_mla_elt_to_128v4hi_vec_concatz_be */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (pattern1238 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[1], E_V2SImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1651 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2018; /* *aarch64_mla_eltv2si_vec_concatz_be */

                    case E_V4SImode:
                      if (!register_operand (operands[1], E_V4SImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1669 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2026; /* *aarch64_mla_elt_to_128v2si_vec_concatz_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x14;
              x5 = XEXP (x2, 0);
              operands[4] = x5;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x6 = XEXP (x3, 1);
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1083 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1685 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2030; /* aarch64_mla_nv4hi_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1083 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1685 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2034; /* aarch64_mla_nv2si_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          switch (pattern762 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2796; /* *aarch64_saddlpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2804; /* *aarch64_saddlpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2814; /* *aarch64_saddlpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern762 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2799; /* *aarch64_uaddlpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2807; /* *aarch64_uaddlpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2817; /* *aarch64_uaddlpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x18 = XEXP (x6, 0);
          if (GET_CODE (x18) != VEC_CONCAT)
            return -1;
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x19 = XEXP (x6, 1);
          operands[4] = x19;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x18, 1);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1239 (x2, 
E_V16QImode, 
E_V8QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4373; /* aarch64_addpv8qi_vec_concatz_be_insn */

            case E_V8HImode:
              if (pattern1239 (x2, 
E_V8HImode, 
E_V4HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4376; /* aarch64_addpv4hi_vec_concatz_be_insn */

            case E_V4SImode:
              if (pattern1239 (x2, 
E_V4SImode, 
E_V2SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4379; /* aarch64_addpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x6 = XEXP (x3, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1084 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4213; /* aarch64_cmtstv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1084 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4217; /* aarch64_cmtstv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1084 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4221; /* aarch64_cmtstv2si_vec_concatz_be */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1020 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4226; /* *aarch64_cmtst_same_v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1020 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4230; /* *aarch64_cmtst_same_v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1020 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4234; /* *aarch64_cmtst_same_v2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern917 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2416; /* fmav4hf4_vec_concatz_le */

        case E_V4SFmode:
          if (pattern917 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2420; /* fmav2sf4_vec_concatz_le */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          if (GET_MODE (x8) != E_SFmode)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_V2SFmode
              || GET_MODE (x4) != E_V2SFmode)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          x6 = XEXP (x3, 2);
          operands[4] = x6;
          if (!register_operand (operands[4], E_V2SFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[5] = x7;
          if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2425; /* *aarch64_fma4_eltv2sf_vec_concatz_le */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2886 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2430; /* *aarch64_fma4_elt_to_128v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x6 = XEXP (x3, 2);
          operands[3] = x6;
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern974 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2434; /* *aarch64_fma4_elt_from_dupv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern974 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2438; /* *aarch64_fma4_elt_from_dupv2si_vec_concatz_le */

            case E_V8HFmode:
              if (pattern974 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2442; /* *aarch64_fma4_elt_from_dupv4hf_vec_concatz_le */

            case E_V4SFmode:
              if (pattern974 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2446; /* *aarch64_fma4_elt_from_dupv2sf_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x6 = XEXP (x3, 2);
          operands[3] = x6;
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern975 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2452; /* fnmav4hf4_vec_concatz_le */

            case E_V4SFmode:
              if (pattern975 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2456; /* fnmav2sf4_vec_concatz_le */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (GET_MODE (x12) != E_SFmode)
                return -1;
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != PARALLEL
                  || XVECLEN (x13, 0) != 1
                  || !register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || GET_MODE (x3) != E_V2SFmode
                  || GET_MODE (x4) != E_V2SFmode)
                return -1;
              x8 = XEXP (x4, 0);
              operands[3] = x8;
              if (!register_operand (operands[3], E_V2SFmode)
                  || GET_MODE (x5) != E_V2SFmode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x3, 2);
              operands[4] = x6;
              if (!register_operand (operands[4], E_V2SFmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[5] = x7;
              if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2943 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2461; /* *aarch64_fnma4_eltv2sf_vec_concatz_le */

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2961 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2466; /* *aarch64_fnma4_elt_to_128v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x12;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x6 = XEXP (x3, 2);
              operands[3] = x6;
              x7 = XEXP (x2, 1);
              operands[4] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1035 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2470; /* *aarch64_fnma4_elt_from_dupv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1035 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2474; /* *aarch64_fnma4_elt_from_dupv2si_vec_concatz_le */

                case E_V8HFmode:
                  if (pattern1035 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 2478; /* *aarch64_fnma4_elt_from_dupv4hf_vec_concatz_le */

                case E_V4SFmode:
                  if (pattern1035 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2482; /* *aarch64_fnma4_elt_from_dupv2sf_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case IOR:
      switch (pattern320 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1328; /* iornv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1332; /* iornv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1336; /* iornv2si3_vec_concatz_le */

        case 3:
          if (pattern826 (x3, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1777; /* iorv8qi3_vec_concatz_le */

        case 4:
          if (pattern826 (x3, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1781; /* iorv4hi3_vec_concatz_le */

        case 5:
          if (pattern826 (x3, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1785; /* iorv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      return recog_496 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern320 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1341; /* andnv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1345; /* andnv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1349; /* andnv2si3_vec_concatz_le */

        case 3:
          if (pattern835 (x3, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1764; /* andv8qi3_vec_concatz_le */

        case 4:
          if (pattern835 (x3, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1768; /* andv4hi3_vec_concatz_le */

        case 5:
          if (pattern835 (x3, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1772; /* andv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case PLUS:
      return recog_497 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_503 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern323 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1380; /* mulv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1384; /* mulv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1388; /* mulv2si3_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2379; /* mulv4hf3_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2653 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2383; /* mulv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case BITREVERSE:
      if (pattern324 (x3) != 0
          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 1397; /* aarch64_rbitv8qi_vec_concatz_le */

    case UNSPEC:
      return recog_500 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_501 (x1, insn, pnum_clobbers);

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1613; /* absv8qi2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1617; /* absv4hi2_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1621; /* absv2si2_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2407; /* absv4hf2_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2411; /* absv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern433 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 1750; /* fabdv4hf3_vec_concatz_le */

            case E_V4SFmode:
              if (pattern433 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1754; /* fabdv2sf3_vec_concatz_le */

            case E_V2DFmode:
              if (pattern433 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1761; /* fabddf3_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern836 (x3, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1790; /* xorv8qi3_vec_concatz_le */

            case E_V8HImode:
              if (pattern836 (x3, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1794; /* xorv4hi3_vec_concatz_le */

            case E_V4SImode:
              if (pattern836 (x3, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1798; /* xorv2si3_vec_concatz_le */

            default:
              return -1;
            }

        case AND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR)
            return -1;
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          x7 = XEXP (x5, 1);
          operands[1] = x7;
          x8 = XEXP (x3, 1);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern973 (x3, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              x9 = XEXP (x4, 1);
              if (rtx_equal_p (x9, operands[3])
                  && (
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return 2891; /* aarch64_simd_bslv8qi_internal_vec_concatz_le */
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2904; /* *aarch64_simd_bslv8qi_alt_vec_concatz_le */

            case E_V8HImode:
              if (pattern973 (x3, 
E_V4HImode, 
E_V8HImode) != 0)
                return -1;
              x9 = XEXP (x4, 1);
              if (rtx_equal_p (x9, operands[3])
                  && (
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return 2895; /* aarch64_simd_bslv4hi_internal_vec_concatz_le */
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2908; /* *aarch64_simd_bslv4hi_alt_vec_concatz_le */

            case E_V4SImode:
              if (pattern973 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
                return -1;
              x9 = XEXP (x4, 1);
              if (rtx_equal_p (x9, operands[3])
                  && (
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return 2899; /* aarch64_simd_bslv2si_internal_vec_concatz_le */
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2912; /* *aarch64_simd_bslv2si_alt_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1803; /* one_cmplv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1807; /* one_cmplv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1811; /* one_cmplv2si2_vec_concatz_le */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern328 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1269 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1868; /* aarch64_simd_lshrv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1269 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1872; /* aarch64_simd_lshrv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1269 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1876; /* aarch64_simd_lshrv2si_vec_concatz_le */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern328 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1881; /* aarch64_simd_ashrv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1885; /* aarch64_simd_ashrv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1889; /* aarch64_simd_ashrv2si_vec_concatz_le */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern837 (x3, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1931; /* aarch64_simd_imm_shlv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern837 (x3, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1935; /* aarch64_simd_imm_shlv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern837 (x3, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1393 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1939; /* aarch64_simd_imm_shlv2si_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern321 (x3, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1404 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1944; /* aarch64_simd_reg_sshlv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern321 (x3, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1404 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1948; /* aarch64_simd_reg_sshlv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern321 (x3, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1404 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1952; /* aarch64_simd_reg_sshlv2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2073; /* smaxv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2089; /* smaxv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2105; /* smaxv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2076; /* sminv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2092; /* sminv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2108; /* sminv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2079; /* umaxv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2095; /* umaxv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2111; /* umaxv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2082; /* uminv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2098; /* uminv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2114; /* uminv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_499 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_498 (x1, insn, pnum_clobbers);

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern321 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2388; /* *divv4hf3_vec_concatz_le */

        case E_V4SFmode:
          if (pattern321 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2392; /* *divv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case FMA:
      return recog_502 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          operands[2] = x8;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern557 (x3, 
E_V2SFmode, 
E_V2DFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3253 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2661; /* truncv2dfv2sf2_vec_concatz_le */

            case E_V8HFmode:
              if (pattern557 (x3, 
E_V4HFmode, 
E_V4SFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3253 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2664; /* truncv4sfv4hf2_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern555 (x3, 
E_V2SFmode, 
E_V2DFmode, 
E_V4SFmode) != 0
                  || !
#line 3275 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2668; /* aarch64_float_truncate_hi_v4sf_be */

            case E_V8HFmode:
              if (pattern555 (x3, 
E_V4HFmode, 
E_V4SFmode, 
E_V8HFmode) != 0
                  || !
#line 3275 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2669; /* aarch64_float_truncate_hi_v8hf_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CLRSB:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2819; /* clrsbv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2823; /* clrsbv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2827; /* clrsbv2si2_vec_concatz_le */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2831; /* clzv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2835; /* clzv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2839; /* clzv2si2_vec_concatz_le */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pattern324 (x3) != 0
          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3565 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 2843; /* popcountv8qi2_vec_concatz_le */

    case SS_PLUS:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3243; /* ssaddv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3259; /* ssaddv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3275; /* ssaddv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3246; /* usaddv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3262; /* usaddv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3278; /* usaddv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3249; /* sssubv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3265; /* sssubv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3281; /* sssubv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern329 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3252; /* ussubv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3268; /* ussubv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3284; /* ussubv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              switch (pattern558 (x3))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5400 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3355; /* aarch64_sqmovnv8hi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5400 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3361; /* aarch64_sqmovnv4si_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5400 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3367; /* aarch64_sqmovnv2di_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern556 (x3))
                {
                case 0:
                  if (!
#line 5422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3378; /* aarch64_sqxtn2v8hi_be */

                case 1:
                  if (!
#line 5422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3380; /* aarch64_sqxtn2v4si_be */

                case 2:
                  if (!
#line 5422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3382; /* aarch64_sqxtn2v2di_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern444 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3900; /* *aarch64_sqsshrn_nv8hi_insn_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3918; /* *aarch64_sqsshrn_nv4si_insn_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3936; /* *aarch64_sqsshrn_nv2di_insn_vec_concatz_le */

            case 3:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4028; /* aarch64_sqsshrn2_nv8hi_insn_be */

            case 4:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4034; /* aarch64_sqsshrn2_nv4si_insn_be */

            case 5:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4040; /* aarch64_sqsshrn2_nv2di_insn_be */

            case 6:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3954; /* *aarch64_sqrshrn_nv8hi_insn_vec_concatz_le */

            case 7:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3963; /* *aarch64_sqrshrn_nv4si_insn_vec_concatz_le */

            case 8:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3972; /* *aarch64_sqrshrn_nv2di_insn_vec_concatz_le */

            case 9:
              if (!
#line 7011 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4055; /* aarch64_sqrshrn2_nv8hi_insn_be */

            case 10:
              if (!
#line 7011 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4058; /* aarch64_sqrshrn2_nv4si_insn_be */

            case 11:
              if (!
#line 7011 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4061; /* aarch64_sqrshrn2_nv2di_insn_be */

            default:
              return -1;
            }

        case LSHIFTRT:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              switch (pattern435 (x3))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                    return -1;
                  return 3903; /* *aarch64_sqshrn_nv8hi_insn_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                    return -1;
                  return 3921; /* *aarch64_sqshrn_nv4si_insn_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                    return -1;
                  return 3939; /* *aarch64_sqshrn_nv2di_insn_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern436 (x3))
                {
                case 0:
                  if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                    return -1;
                  return 4029; /* aarch64_squshrn2_nv8hi_insn_be */

                case 1:
                  if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                    return -1;
                  return 4035; /* aarch64_squshrn2_nv4si_insn_be */

                case 2:
                  if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                    return -1;
                  return 4041; /* aarch64_squshrn2_nv2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      return recog_504 (x1, insn, pnum_clobbers);

    case SS_NEG:
      switch (pattern330 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3403; /* aarch64_sqnegv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3411; /* aarch64_sqnegv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3419; /* aarch64_sqnegv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3435; /* aarch64_sqnegdi_vec_concatz_le */

        default:
          return -1;
        }

    case SS_ABS:
      switch (pattern330 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3406; /* aarch64_sqabsv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3414; /* aarch64_sqabsv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3422; /* aarch64_sqabsv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3438; /* aarch64_sqabsdi_vec_concatz_le */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern325 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7550 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4385; /* *sqrtv4hf2_vec_concatz_le */

        case E_V4SFmode:
          if (pattern325 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7550 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4389; /* *sqrtv2sf2_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern12 (x1))
    {
    case 0:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 922; /* lbtruncuhfsi2 */

    case 1:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 942; /* lbtruncusfsi2 */

    case 2:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 962; /* lbtruncudfsi2 */

    case 3:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 932; /* lbtruncuhfdi2 */

    case 4:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 952; /* lbtruncusfdi2 */

    case 5:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 972; /* lbtruncudfdi2 */

    case 6:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2555; /* lbtruncuv4hfv4hi2 */

    case 7:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2565; /* lbtruncuv8hfv8hi2 */

    case 8:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2575; /* lbtruncuv2sfv2si2 */

    case 9:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2585; /* lbtruncuv4sfv4si2 */

    case 10:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2595; /* lbtruncuv2dfv2di2 */

    case 11:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2605; /* lbtruncuhfhi2 */

    case 12:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2SFmode)))))
        return -1;
      return 2615; /* *aarch64_fcvtuv2sfv2si2_mult */

    case 13:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V4SFmode)))))
        return -1;
      return 2617; /* *aarch64_fcvtuv4sfv4si2_mult */

    case 14:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2DFmode)))))
        return -1;
      return 2619; /* *aarch64_fcvtuv2dfv2di2_mult */

    case 15:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 923; /* lceiluhfsi2 */

    case 16:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 943; /* lceilusfsi2 */

    case 17:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 963; /* lceiludfsi2 */

    case 18:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 933; /* lceiluhfdi2 */

    case 19:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 953; /* lceilusfdi2 */

    case 20:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 973; /* lceiludfdi2 */

    case 21:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2556; /* lceiluv4hfv4hi2 */

    case 22:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2566; /* lceiluv8hfv8hi2 */

    case 23:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2576; /* lceiluv2sfv2si2 */

    case 24:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2586; /* lceiluv4sfv4si2 */

    case 25:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2596; /* lceiluv2dfv2di2 */

    case 26:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2606; /* lceiluhfhi2 */

    case 27:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 924; /* lflooruhfsi2 */

    case 28:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 944; /* lfloorusfsi2 */

    case 29:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 964; /* lfloorudfsi2 */

    case 30:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 934; /* lflooruhfdi2 */

    case 31:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 954; /* lfloorusfdi2 */

    case 32:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 974; /* lfloorudfdi2 */

    case 33:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2557; /* lflooruv4hfv4hi2 */

    case 34:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2567; /* lflooruv8hfv8hi2 */

    case 35:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2577; /* lflooruv2sfv2si2 */

    case 36:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2587; /* lflooruv4sfv4si2 */

    case 37:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2597; /* lflooruv2dfv2di2 */

    case 38:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2607; /* lflooruhfhi2 */

    case 39:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 925; /* lrounduhfsi2 */

    case 40:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 945; /* lroundusfsi2 */

    case 41:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 965; /* lroundudfsi2 */

    case 42:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 935; /* lrounduhfdi2 */

    case 43:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 955; /* lroundusfdi2 */

    case 44:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 975; /* lroundudfdi2 */

    case 45:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2558; /* lrounduv4hfv4hi2 */

    case 46:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2568; /* lrounduv8hfv8hi2 */

    case 47:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2578; /* lrounduv2sfv2si2 */

    case 48:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2588; /* lrounduv4sfv4si2 */

    case 49:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2598; /* lrounduv2dfv2di2 */

    case 50:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2608; /* lrounduhfhi2 */

    case 51:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 926; /* lfrintnuhfsi2 */

    case 52:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 946; /* lfrintnusfsi2 */

    case 53:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 966; /* lfrintnudfsi2 */

    case 54:
      if (!(
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 936; /* lfrintnuhfdi2 */

    case 55:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 956; /* lfrintnusfdi2 */

    case 56:
      if (!
#line 6855 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 976; /* lfrintnudfdi2 */

    case 57:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2559; /* lfrintnuv4hfv4hi2 */

    case 58:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2569; /* lfrintnuv8hfv8hi2 */

    case 59:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2579; /* lfrintnuv2sfv2si2 */

    case 60:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2589; /* lfrintnuv4sfv4si2 */

    case 61:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2599; /* lfrintnuv2dfv2di2 */

    case 62:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2609; /* lfrintnuhfhi2 */

    case 63:
      if (!
#line 6866 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 978; /* *aarch64_fcvtusfsi2_mult */

    case 64:
      if (!
#line 6866 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 982; /* *aarch64_fcvtudfsi2_mult */

    case 65:
      if (!
#line 6866 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 980; /* *aarch64_fcvtusfdi2_mult */

    case 66:
      if (!
#line 6866 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 984; /* *aarch64_fcvtudfdi2_mult */

    case 67:
      if (!
#line 7028 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1004; /* fixuns_truncsfsi2 */

    case 68:
      if (!
#line 7040 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1008; /* fixuns_trunchfsi2 */

    case 69:
      if (!
#line 7051 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1012; /* fixuns_truncdfsi2 */

    case 70:
      if (!
#line 7028 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1006; /* fixuns_truncdfdi2 */

    case 71:
      if (!
#line 7040 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1010; /* fixuns_trunchfdi2 */

    case 72:
      if (!
#line 7051 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1014; /* fixuns_truncsfdi2 */

    case 73:
      if (!
#line 3035 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2611; /* fixuns_trunchfhi2 */

    case 74:
      if (!
#line 3440 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12664; /* fixunsvnx8sfvnx8si2 */

    case 75:
      if (!
#line 3440 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12666; /* fixunsvnx16sfvnx16si2 */

    default:
      return -1;
    }
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern36 (x3))
    {
    case 0:
      if (!
#line 7384 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
        return -1;
      return 1084; /* *aarch64_umaxsi3_cssc */

    case 1:
      if (!
#line 7384 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
        return -1;
      return 1088; /* *aarch64_umaxdi3_cssc */

    case 2:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2078; /* umaxv8qi3 */

    case 3:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2086; /* umaxv16qi3 */

    case 4:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2094; /* umaxv4hi3 */

    case 5:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2102; /* umaxv8hi3 */

    case 6:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2110; /* umaxv2si3 */

    case 7:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2118; /* umaxv4si3 */

    case 8:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11458; /* *umaxvnx32qi3 */

    case 9:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11462; /* *umaxvnx16hi3 */

    case 10:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11466; /* *umaxvnx8si3 */

    case 11:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11470; /* *umaxvnx4di3 */

    case 12:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11474; /* *umaxvnx64qi3 */

    case 13:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11478; /* *umaxvnx32hi3 */

    case 14:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11482; /* *umaxvnx16si3 */

    case 15:
      if (!
#line 735 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11486; /* *umaxvnx8di3 */

    case 16:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7422; /* *post_ra_umaxvnx16qi3 */

    case 17:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7427; /* *post_ra_umaxvnx8qi3 */

    case 18:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7432; /* *post_ra_umaxvnx4qi3 */

    case 19:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7437; /* *post_ra_umaxvnx2qi3 */

    case 20:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7442; /* *post_ra_umaxvnx8hi3 */

    case 21:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7447; /* *post_ra_umaxvnx4hi3 */

    case 22:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7452; /* *post_ra_umaxvnx2hi3 */

    case 23:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7457; /* *post_ra_umaxvnx4si3 */

    case 24:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7462; /* *post_ra_umaxvnx2si3 */

    case 25:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7467; /* *post_ra_umaxvnx2di3 */

    case 26:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7472; /* *post_ra_umaxv2di3 */

    case 27:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11491; /* aarch64_sve_single_umaxvnx32qi */

    case 28:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11496; /* aarch64_sve_single_umaxvnx16hi */

    case 29:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11501; /* aarch64_sve_single_umaxvnx8si */

    case 30:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11506; /* aarch64_sve_single_umaxvnx4di */

    case 31:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11511; /* aarch64_sve_single_umaxvnx64qi */

    case 32:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11516; /* aarch64_sve_single_umaxvnx32hi */

    case 33:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11521; /* aarch64_sve_single_umaxvnx16si */

    case 34:
      if (!
#line 745 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11526; /* aarch64_sve_single_umaxvnx8di */

    default:
      return -1;
    }
}

 int
recog_543 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 7001 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1000; /* truncdfsf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 7009 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1001; /* truncsfhf2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 7017 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1002; /* truncdfhf2 */

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 3253 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2660; /* truncv2dfv2sf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3253 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2663; /* truncv4sfv4hf2 */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3368 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12651; /* truncvnx8sfvnx8bf2 */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3368 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12652; /* truncvnx8sfvnx8hf2 */

    default:
      return -1;
    }
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10100; /* *while_wrsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10110; /* *while_wrdivnx4bi_cc */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10179; /* while_rwsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10189; /* while_rwdivnx4bi_ptest */
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10059; /* *while_rwsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10069; /* *while_rwdivnx16bi_cc */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10058; /* *while_ugesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10068; /* *while_ugedivnx16bi_cc */
}

 int
recog_580 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10176; /* while_gtsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10186; /* while_gtdivnx4bi_ptest */
}

 int
recog_590 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10135; /* while_gesivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10145; /* while_gedivnx16bi_ptest */
}

 int
recog_600 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern454 (x2, 
66, 
E_CC_NZCmode, 
CLOBBER) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  switch (GET_CODE (x7))
    {
    case LT:
      switch (pattern1185 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9481; /* aarch64_pred_cmpltvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9491; /* aarch64_pred_cmpltvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9521; /* aarch64_pred_cmpltvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9501; /* aarch64_pred_cmpltvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9531; /* aarch64_pred_cmpltvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9551; /* aarch64_pred_cmpltvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9511; /* aarch64_pred_cmpltvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9541; /* aarch64_pred_cmpltvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9561; /* aarch64_pred_cmpltvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9571; /* aarch64_pred_cmpltvnx2di */

        default:
          return -1;
        }

    case LE:
      switch (pattern1185 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9482; /* aarch64_pred_cmplevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9492; /* aarch64_pred_cmplevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9522; /* aarch64_pred_cmplevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9502; /* aarch64_pred_cmplevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9532; /* aarch64_pred_cmplevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9552; /* aarch64_pred_cmplevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9512; /* aarch64_pred_cmplevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9542; /* aarch64_pred_cmplevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9562; /* aarch64_pred_cmplevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9572; /* aarch64_pred_cmplevnx2di */

        default:
          return -1;
        }

    case EQ:
      switch (pattern1185 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9483; /* aarch64_pred_cmpeqvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9493; /* aarch64_pred_cmpeqvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9523; /* aarch64_pred_cmpeqvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9503; /* aarch64_pred_cmpeqvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9533; /* aarch64_pred_cmpeqvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9553; /* aarch64_pred_cmpeqvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9513; /* aarch64_pred_cmpeqvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9543; /* aarch64_pred_cmpeqvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9563; /* aarch64_pred_cmpeqvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9573; /* aarch64_pred_cmpeqvnx2di */

        default:
          return -1;
        }

    case NE:
      switch (pattern1185 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9484; /* aarch64_pred_cmpnevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9494; /* aarch64_pred_cmpnevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9524; /* aarch64_pred_cmpnevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9504; /* aarch64_pred_cmpnevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9534; /* aarch64_pred_cmpnevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9554; /* aarch64_pred_cmpnevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9514; /* aarch64_pred_cmpnevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9544; /* aarch64_pred_cmpnevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9564; /* aarch64_pred_cmpnevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9574; /* aarch64_pred_cmpnevnx2di */

        default:
          return -1;
        }

    case GE:
      switch (pattern1185 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9485; /* aarch64_pred_cmpgevnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9495; /* aarch64_pred_cmpgevnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9525; /* aarch64_pred_cmpgevnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9505; /* aarch64_pred_cmpgevnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9535; /* aarch64_pred_cmpgevnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9555; /* aarch64_pred_cmpgevnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9515; /* aarch64_pred_cmpgevnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9545; /* aarch64_pred_cmpgevnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9565; /* aarch64_pred_cmpgevnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9575; /* aarch64_pred_cmpgevnx2di */

        default:
          return -1;
        }

    case GT:
      switch (pattern1185 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9486; /* aarch64_pred_cmpgtvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9496; /* aarch64_pred_cmpgtvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9526; /* aarch64_pred_cmpgtvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9506; /* aarch64_pred_cmpgtvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9536; /* aarch64_pred_cmpgtvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9556; /* aarch64_pred_cmpgtvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9516; /* aarch64_pred_cmpgtvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9546; /* aarch64_pred_cmpgtvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9566; /* aarch64_pred_cmpgtvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9576; /* aarch64_pred_cmpgtvnx2di */

        default:
          return -1;
        }

    case LTU:
      switch (pattern1186 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9487; /* aarch64_pred_cmplovnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9497; /* aarch64_pred_cmplovnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9527; /* aarch64_pred_cmplovnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9507; /* aarch64_pred_cmplovnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9537; /* aarch64_pred_cmplovnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9557; /* aarch64_pred_cmplovnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9517; /* aarch64_pred_cmplovnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9547; /* aarch64_pred_cmplovnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9567; /* aarch64_pred_cmplovnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9577; /* aarch64_pred_cmplovnx2di */

        default:
          return -1;
        }

    case LEU:
      switch (pattern1186 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9488; /* aarch64_pred_cmplsvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9498; /* aarch64_pred_cmplsvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9528; /* aarch64_pred_cmplsvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9508; /* aarch64_pred_cmplsvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9538; /* aarch64_pred_cmplsvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9558; /* aarch64_pred_cmplsvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9518; /* aarch64_pred_cmplsvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9548; /* aarch64_pred_cmplsvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9568; /* aarch64_pred_cmplsvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9578; /* aarch64_pred_cmplsvnx2di */

        default:
          return -1;
        }

    case GEU:
      switch (pattern1186 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9489; /* aarch64_pred_cmphsvnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9499; /* aarch64_pred_cmphsvnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9529; /* aarch64_pred_cmphsvnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9509; /* aarch64_pred_cmphsvnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9539; /* aarch64_pred_cmphsvnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9559; /* aarch64_pred_cmphsvnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9519; /* aarch64_pred_cmphsvnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9549; /* aarch64_pred_cmphsvnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9569; /* aarch64_pred_cmphsvnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9579; /* aarch64_pred_cmphsvnx2di */

        default:
          return -1;
        }

    case GTU:
      switch (pattern1186 (x4))
        {
        case 0:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9490; /* aarch64_pred_cmphivnx16qi */

        case 1:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9500; /* aarch64_pred_cmphivnx8qi */

        case 2:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9530; /* aarch64_pred_cmphivnx8hi */

        case 3:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9510; /* aarch64_pred_cmphivnx4qi */

        case 4:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9540; /* aarch64_pred_cmphivnx4hi */

        case 5:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9560; /* aarch64_pred_cmphivnx4si */

        case 6:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9520; /* aarch64_pred_cmphivnx2qi */

        case 7:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9550; /* aarch64_pred_cmphivnx2hi */

        case 8:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9570; /* aarch64_pred_cmphivnx2si */

        case 9:
          if (!
#line 8184 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9580; /* aarch64_pred_cmphivnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x7, 0) != 2)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[4] = x9;
      switch (XINT (x7, 1))
        {
        case 341:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9881; /* aarch64_pred_cmpeqvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9891; /* aarch64_pred_cmpeqvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9901; /* aarch64_pred_cmpeqvnx4si_wide */

            default:
              return -1;
            }

        case 342:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9882; /* aarch64_pred_cmpgevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9892; /* aarch64_pred_cmpgevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9902; /* aarch64_pred_cmpgevnx4si_wide */

            default:
              return -1;
            }

        case 343:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9883; /* aarch64_pred_cmpgtvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9893; /* aarch64_pred_cmpgtvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9903; /* aarch64_pred_cmpgtvnx4si_wide */

            default:
              return -1;
            }

        case 344:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9884; /* aarch64_pred_cmphivnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9894; /* aarch64_pred_cmphivnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9904; /* aarch64_pred_cmphivnx4si_wide */

            default:
              return -1;
            }

        case 345:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9885; /* aarch64_pred_cmphsvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9895; /* aarch64_pred_cmphsvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9905; /* aarch64_pred_cmphsvnx4si_wide */

            default:
              return -1;
            }

        case 346:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9886; /* aarch64_pred_cmplevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9896; /* aarch64_pred_cmplevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9906; /* aarch64_pred_cmplevnx4si_wide */

            default:
              return -1;
            }

        case 347:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9887; /* aarch64_pred_cmplovnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9897; /* aarch64_pred_cmplovnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9907; /* aarch64_pred_cmplovnx4si_wide */

            default:
              return -1;
            }

        case 348:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9888; /* aarch64_pred_cmplsvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9898; /* aarch64_pred_cmplsvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9908; /* aarch64_pred_cmplsvnx4si_wide */

            default:
              return -1;
            }

        case 349:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9889; /* aarch64_pred_cmpltvnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9899; /* aarch64_pred_cmpltvnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9909; /* aarch64_pred_cmpltvnx4si_wide */

            default:
              return -1;
            }

        case 350:
          switch (pattern1292 (x4))
            {
            case 0:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9890; /* aarch64_pred_cmpnevnx16qi_wide */

            case 1:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9900; /* aarch64_pred_cmpnevnx8hi_wide */

            case 2:
              if (!
#line 8313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9910; /* aarch64_pred_cmpnevnx4si_wide */

            default:
              return -1;
            }

        case 473:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern1300 (x4, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12953; /* aarch64_pred_matchvnx16qi */

            case E_VNx8BImode:
              if (pattern1300 (x4, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12955; /* aarch64_pred_matchvnx8hi */

            default:
              return -1;
            }

        case 474:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern1300 (x4, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12954; /* aarch64_pred_nmatchvnx16qi */

            case E_VNx8BImode:
              if (pattern1300 (x4, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 4020 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
                return -1;
              return 12956; /* aarch64_pred_nmatchvnx8hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_623 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      return recog_514 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (aarch64_comparison_operator (x3, E_VOIDmode))
            {
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) == CONST_INT)
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x3;
          if (!aarch64_comparison_operation (operands[1], E_VOIDmode))
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              switch (pattern585 (x2))
                {
                case 0:
                  return 475; /* csinc3si_insn */

                case 1:
                  return 476; /* csinc3di_insn */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern585 (x2))
                {
                case 0:
                  return 477; /* *csinv3si_insn */

                case 1:
                  return 478; /* *csinv3di_insn */

                default:
                  return -1;
                }

            case NEG:
              switch (pattern585 (x2))
                {
                case 0:
                  return 481; /* csneg3si_insn */

                case 1:
                  return 482; /* csneg3di_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              x8 = XEXP (x6, 0);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x9 = XEXP (x2, 2);
                  if (GET_CODE (x9) != ZERO_EXTEND
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_SImode)
                    return -1;
                  switch (GET_CODE (x10))
                    {
                    case NEG:
                      x11 = XEXP (x10, 0);
                      operands[3] = x11;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      return 483; /* *csinv3_uxtw_insn1 */

                    case NOT:
                      x11 = XEXP (x10, 0);
                      operands[3] = x11;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      return 484; /* *csinv3_uxtw_insn1 */

                    default:
                      return -1;
                    }

                case NEG:
                  switch (pattern939 (x2))
                    {
                    case 0:
                      return 485; /* *csinv3_uxtw_insn2 */

                    case 1:
                      return 487; /* *csinv3_uxtw_insn3 */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern939 (x2))
                    {
                    case 0:
                      return 486; /* *csinv3_uxtw_insn2 */

                    case 1:
                      return 488; /* *csinv3_uxtw_insn3 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_512 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_511 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_522 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_507 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_510 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_518 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_521 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_529 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_534 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_509 (x1, insn, pnum_clobbers);

    case DIV:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) != 0)
            return -1;
          return 399; /* divsi3 */

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) != 0)
            return -1;
          return 401; /* divdi3 */

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) != 0
              || !(
#line 7321 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1070; /* *divhf3 */

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) != 0
              || !
#line 7321 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1071; /* *divsf3 */

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) != 0
              || !
#line 7321 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1072; /* *divdf3 */

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) != 0
              || !(
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2387; /* *divv4hf3 */

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) != 0
              || !(
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2390; /* *divv8hf3 */

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) != 0
              || !
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2391; /* *divv2sf3 */

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) != 0
              || !
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2394; /* *divv4sf3 */

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) != 0
              || !
#line 2674 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2395; /* *divv2df3 */

        default:
          return -1;
        }

    case UDIV:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) != 0)
            return -1;
          return 400; /* udivsi3 */

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) != 0)
            return -1;
          return 402; /* udivdi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x3 = XEXP (x2, 0);
          operands[2] = x3;
          if (cc_register (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (register_operand (operands[0], E_QImode)
                      && aarch64_comparison_operator_mode (operands[1], E_QImode))
                    return 441; /* aarch64_cstoreqi */
                  break;

                case E_HImode:
                  if (register_operand (operands[0], E_HImode)
                      && aarch64_comparison_operator_mode (operands[1], E_HImode))
                    return 442; /* aarch64_cstorehi */
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && aarch64_comparison_operator_mode (operands[1], E_SImode))
                    return 443; /* aarch64_cstoresi */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && aarch64_comparison_operator_mode (operands[1], E_DImode))
                    return 444; /* aarch64_cstoredi */
                  break;

                default:
                  break;
                }
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      operands[2] = x6;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern754 (x2, 
E_SImode) != 0
                  || !
#line 4461 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 445; /* *compare_cstoresi_insn */

            case E_DImode:
              if (pattern754 (x2, 
E_DImode) != 0
                  || !
#line 4461 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 447; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        case NE:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern754 (x2, 
E_SImode) != 0
                  || !
#line 4461 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 446; /* *compare_cstoresi_insn */

            case E_DImode:
              if (pattern754 (x2, 
E_DImode) != 0
                  || !
#line 4461 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 448; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_524 (x1, insn, pnum_clobbers);

    case AND:
      return recog_508 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_523 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          return 688; /* clzsi2 */

        case 1:
          return 689; /* clzdi2 */

        case 2:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2830; /* clzv8qi2 */

        case 3:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2833; /* clzv16qi2 */

        case 4:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2834; /* clzv4hi2 */

        case 5:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2837; /* clzv8hi2 */

        case 6:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2838; /* clzv2si2 */

        case 7:
          if (!
#line 3557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2841; /* clzv4si2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 5543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 690; /* *aarch64_popcountsi2_cssc_insn */

        case 1:
          if (!
#line 5543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 691; /* *aarch64_popcountdi2_cssc_insn */

        case 2:
          if (!
#line 3565 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2842; /* popcountv8qi2 */

        case 3:
          if (!
#line 3565 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2845; /* popcountv16qi2 */

        default:
          return -1;
        }

    case CLRSB:
      switch (pattern0 (x1))
        {
        case 0:
          return 692; /* clrsbsi2 */

        case 1:
          return 693; /* clrsbdi2 */

        case 2:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2818; /* clrsbv8qi2 */

        case 3:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2821; /* clrsbv16qi2 */

        case 4:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2822; /* clrsbv4hi2 */

        case 5:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2825; /* clrsbv8hi2 */

        case 6:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2826; /* clrsbv2si2 */

        case 7:
          if (!
#line 3549 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2829; /* clrsbv4si2 */

        default:
          return -1;
        }

    case BITREVERSE:
      switch (pattern1 (x1))
        {
        case 0:
          return 694; /* aarch64_rbitsi */

        case 1:
          return 695; /* aarch64_rbitdi */

        case 2:
          if (!
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1396; /* aarch64_rbitv8qi */

        case 3:
          if (!
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1399; /* aarch64_rbitv16qi */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern3 (x1))
        {
        case 0:
          return 696; /* ctzsi2 */

        case 1:
          return 697; /* ctzdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_533 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_538 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_539 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      if (subreg_lowpart_operator (x6, E_VOIDmode))
        {
          operands[4] = x6;
          switch (pattern524 (x2))
            {
            case 0:
              if (
#line 5858 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                return 721; /* *aarch64_rotr_reg_si3_mask1 */
              break;

            case 1:
              if (
#line 5858 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                return 726; /* *aarch64_rotr_reg_di3_mask1 */
              break;

            case 2:
              if (
#line 5922 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 743; /* *aarch64_rotr_reg_di3_mask2 */
              break;

            case 3:
              if (
#line 5870 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                return 731; /* *aarch64_rotr_reg_si3_neg_mask2 */
              break;

            case 4:
              if (
#line 5870 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 736; /* *aarch64_rotr_reg_di3_neg_mask2 */
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern416 (x2))
        {
        case 0:
          return 762; /* *rorsi3_insn */

        case 1:
          return 763; /* *rordi3_insn */

        default:
          return -1;
        }

    case ROTATE:
      return recog_532 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (pattern527 (x2))
        {
        case 0:
          if (!
#line 6333 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 814; /* *extvsi */

        case 1:
          if (!
#line 6333 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 816; /* *extvdi */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      res = recog_475 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (XWINT (x6, 0) != 64L
          || GET_CODE (x9) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (XWINT (x9, 0))
        {
        case 0L:
          switch (pattern902 ())
            {
            case 0:
              if (!
#line 7585 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1112; /* aarch64_movdi_tilow */

            case 1:
              if (!
#line 7585 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1113; /* aarch64_movdi_tflow */

            case 2:
              if (!
#line 7585 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1114; /* aarch64_movdi_tdlow */

            default:
              return -1;
            }

        case 64L:
          switch (pattern902 ())
            {
            case 0:
              if (!
#line 7595 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1115; /* aarch64_movdi_tihigh */

            case 1:
              if (!
#line 7595 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1116; /* aarch64_movdi_tfhigh */

            case 2:
              if (!
#line 7595 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1117; /* aarch64_movdi_tdhigh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case TRUNCATE:
    case HIGH:
      return recog_506 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_540 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_526 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_525 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_513 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_536 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_543 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 7107 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1025; /* floatsisf2 */

        case 1:
          if (!
#line 7118 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1029; /* floatdisf2 */

        case 2:
          if (!
#line 7107 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1027; /* floatdidf2 */

        case 3:
          if (!
#line 7118 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1031; /* floatsidf2 */

        case 4:
          if (!
#line 7133 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1033; /* aarch64_fp16_floatsihf2 */

        case 5:
          if (!
#line 7133 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1035; /* aarch64_fp16_floatdihf2 */

        case 6:
          if (!
#line 3043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
            return -1;
          return 2612; /* floathihf2 */

        case 7:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2620; /* floatv4hiv4hf2 */

        case 8:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2622; /* floatv8hiv8hf2 */

        case 9:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2624; /* floatv2siv2sf2 */

        case 10:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2626; /* floatv4siv4sf2 */

        case 11:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2628; /* floatv2div2df2 */

        case 12:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12659; /* floatvnx8sivnx8sf2 */

        case 13:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12661; /* floatvnx16sivnx16sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 7107 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1026; /* floatunssisf2 */

        case 1:
          if (!
#line 7118 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1030; /* floatunsdisf2 */

        case 2:
          if (!
#line 7107 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1028; /* floatunsdidf2 */

        case 3:
          if (!
#line 7118 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1032; /* floatunssidf2 */

        case 4:
          if (!
#line 7133 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1034; /* aarch64_fp16_floatunssihf2 */

        case 5:
          if (!
#line 7133 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1036; /* aarch64_fp16_floatunsdihf2 */

        case 6:
          if (!
#line 3043 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
            return -1;
          return 2613; /* floatunshihf2 */

        case 7:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2621; /* floatunsv4hiv4hf2 */

        case 8:
          if (!(
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2623; /* floatunsv8hiv8hf2 */

        case 9:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2625; /* floatunsv2siv2sf2 */

        case 10:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2627; /* floatunsv4siv4sf2 */

        case 11:
          if (!
#line 3095 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2629; /* floatunsv2div2df2 */

        case 12:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12660; /* floatunsvnx8sivnx8sf2 */

        case 13:
          if (!
#line 3424 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12662; /* floatunsvnx16sivnx16sf2 */

        default:
          return -1;
        }

    case SQRT:
      return recog_537 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_527 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_520 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_535 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_531 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!aarch64_valid_symref (operands[2], E_VOIDmode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 163 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1125; /* add_losym_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1126; /* add_losym_di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_515 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_530 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_505 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_516 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_517 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_542 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_519 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_541 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      return recog_545 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      return recog_544 (x1, insn, pnum_clobbers);

    case SS_NEG:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3402; /* aarch64_sqnegv8qi */

        case 1:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3408; /* aarch64_sqnegv16qi */

        case 2:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3410; /* aarch64_sqnegv4hi */

        case 3:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3416; /* aarch64_sqnegv8hi */

        case 4:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3418; /* aarch64_sqnegv2si */

        case 5:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3424; /* aarch64_sqnegv4si */

        case 6:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3426; /* aarch64_sqnegv2di */

        case 7:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3428; /* aarch64_sqnegqi */

        case 8:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3430; /* aarch64_sqneghi */

        case 9:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3432; /* aarch64_sqnegsi */

        case 10:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3434; /* aarch64_sqnegdi */

        default:
          return -1;
        }

    case SS_ABS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3405; /* aarch64_sqabsv8qi */

        case 1:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3409; /* aarch64_sqabsv16qi */

        case 2:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3413; /* aarch64_sqabsv4hi */

        case 3:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3417; /* aarch64_sqabsv8hi */

        case 4:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3421; /* aarch64_sqabsv2si */

        case 5:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3425; /* aarch64_sqabsv4si */

        case 6:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3427; /* aarch64_sqabsv2di */

        case 7:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3429; /* aarch64_sqabsqi */

        case 8:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3431; /* aarch64_sqabshi */

        case 9:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3433; /* aarch64_sqabssi */

        case 10:
          if (!
#line 5542 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3437; /* aarch64_sqabsdi */

        default:
          return -1;
        }

    case SS_ASHIFT:
      return recog_528 (x1, insn, pnum_clobbers);

    case VEC_SERIES:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx16QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6479; /* vec_seriesvnx16qi */

        case E_VNx8QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx8QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6480; /* vec_seriesvnx8qi */

        case E_VNx4QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx4QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6481; /* vec_seriesvnx4qi */

        case E_VNx2QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx2QImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6482; /* vec_seriesvnx2qi */

        case E_VNx8HImode:
          if (pattern561 (x2, 
E_HImode, 
E_VNx8HImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6483; /* vec_seriesvnx8hi */

        case E_VNx4HImode:
          if (pattern561 (x2, 
E_HImode, 
E_VNx4HImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6484; /* vec_seriesvnx4hi */

        case E_VNx2HImode:
          if (pattern561 (x2, 
E_HImode, 
E_VNx2HImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6485; /* vec_seriesvnx2hi */

        case E_VNx4SImode:
          if (pattern561 (x2, 
E_SImode, 
E_VNx4SImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6486; /* vec_seriesvnx4si */

        case E_VNx2SImode:
          if (pattern561 (x2, 
E_SImode, 
E_VNx2SImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6487; /* vec_seriesvnx2si */

        case E_VNx2DImode:
          if (pattern561 (x2, 
E_DImode, 
E_VNx2DImode) != 0
              || !
#line 2903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6488; /* vec_seriesvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2805 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2853 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2893 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1108 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1680 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1753 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1693 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1766 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1706 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1779 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1719 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1792 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1844 (insn, operands);

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1968 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1971 (insn, operands);

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1969 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1972 (insn, operands);

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1970 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1973 (insn, operands);

        default:
          return NULL;
        }

    case 1L:
      x6 = XVECEXP (x2, 0, 2);
      operands[4] = x6;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return NULL;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1045 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
                  || !((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1857 (insn, operands);

            case E_VNx8HFmode:
              if (pattern1045 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1870 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1045 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1883 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1045 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1896 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1260 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1974 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1260 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1975 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1260 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1976 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      return split_67 (x1, insn);

    case 2:
      return split_66 (x1, insn);

    case 4:
      return split_68 (x1, insn);

    case 5:
      x4 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x4) != CONST_INT)
        return NULL;
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 3);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 4);
      operands[4] = x7;
      switch (XINT (x3, 1))
        {
        case 376:
          switch (pattern1111 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2012 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2028 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2044 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2016 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2032 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2020 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2036 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2052 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2024 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2040 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2056 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2064 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2068 (insn, operands);

            default:
              return NULL;
            }

        case 377:
          switch (pattern1111 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2013 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2029 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2045 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2017 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2033 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2049 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2021 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2037 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2053 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2025 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2041 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2057 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2061 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2065 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2069 (insn, operands);

            default:
              return NULL;
            }

        case 381:
          switch (pattern1111 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2014 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2030 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2046 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2018 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2034 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2050 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2022 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2038 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2054 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2026 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2042 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2058 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2062 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2066 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2070 (insn, operands);

            default:
              return NULL;
            }

        case 382:
          switch (pattern1111 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2015 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2031 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2047 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2019 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2035 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2023 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2039 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2055 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2027 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2043 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2059 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2067 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2071 (insn, operands);

            default:
              return NULL;
            }

        case 360:
          switch (pattern1112 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2072 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2084 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2076 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2088 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2080 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2092 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2096 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2100 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2104 (insn, operands);

            default:
              return NULL;
            }

        case 361:
          switch (pattern1112 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2073 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2085 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2077 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2089 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2081 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2093 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2097 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2101 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2105 (insn, operands);

            default:
              return NULL;
            }

        case 362:
          switch (pattern1112 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2074 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2086 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2078 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2082 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2094 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2098 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2106 (insn, operands);

            default:
              return NULL;
            }

        case 363:
          switch (pattern1112 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2075 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2079 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2091 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2083 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2095 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2099 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2103 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2107 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2537 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2547 (insn, operands);
}

 rtx_insn *
split_88 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2477 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2487 (insn, operands);
}

 rtx_insn *
split_91 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2417 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2427 (insn, operands);
}

 rtx_insn *
split_94 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2516 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2526 (insn, operands);
}

 rtx_insn *
split_97 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2456 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2466 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2535 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2545 (insn, operands);
}

 rtx_insn *
split_105 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2455 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2465 (insn, operands);
}

 rtx_insn *
split_110 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2514 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2524 (insn, operands);
}

 rtx_insn *
split_117 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2533 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2543 (insn, operands);
}

 rtx_insn *
split_124 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2552 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2562 (insn, operands);
}

 rtx_insn *
split_132 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1099 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2408 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2418 (insn, operands);

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2428 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2438 (insn, operands);

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2448 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2458 (insn, operands);

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2468 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2478 (insn, operands);

    case 4:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2488 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2498 (insn, operands);

    case 5:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2508 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2518 (insn, operands);

    case 6:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2528 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2538 (insn, operands);

    case 7:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2548 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2558 (insn, operands);

    case 8:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2409 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2419 (insn, operands);

    case 9:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2429 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2439 (insn, operands);

    case 10:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2449 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2459 (insn, operands);

    case 11:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2469 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2479 (insn, operands);

    case 12:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2489 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2499 (insn, operands);

    case 13:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2509 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2519 (insn, operands);

    case 14:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2529 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2539 (insn, operands);

    case 15:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2549 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2559 (insn, operands);

    case 16:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2410 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2420 (insn, operands);

    case 17:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2430 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2440 (insn, operands);

    case 18:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2450 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2460 (insn, operands);

    case 19:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2470 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2480 (insn, operands);

    case 20:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2490 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2500 (insn, operands);

    case 21:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2510 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2520 (insn, operands);

    case 22:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2530 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2540 (insn, operands);

    case 23:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2550 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2560 (insn, operands);

    case 24:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2411 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2421 (insn, operands);

    case 25:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2431 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2441 (insn, operands);

    case 26:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2451 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2461 (insn, operands);

    case 27:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2471 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2481 (insn, operands);

    case 28:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2491 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2501 (insn, operands);

    case 29:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2511 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2521 (insn, operands);

    case 30:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2531 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2541 (insn, operands);

    case 31:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2551 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2561 (insn, operands);

    case 32:
      return split_131 (x1, insn);

    case 33:
      return split_130 (x1, insn);

    case 34:
      return split_129 (x1, insn);

    case 35:
      return split_128 (x1, insn);

    case 36:
      return split_127 (x1, insn);

    case 37:
      return split_126 (x1, insn);

    case 38:
      return split_125 (x1, insn);

    case 39:
      return split_124 (x1, insn);

    case 40:
      return split_123 (x1, insn);

    case 41:
      return split_122 (x1, insn);

    case 42:
      return split_121 (x1, insn);

    case 43:
      return split_120 (x1, insn);

    case 44:
      return split_119 (x1, insn);

    case 45:
      return split_118 (x1, insn);

    case 46:
      return split_117 (x1, insn);

    case 47:
      return split_116 (x1, insn);

    case 48:
      return split_115 (x1, insn);

    case 49:
      return split_114 (x1, insn);

    case 50:
      return split_113 (x1, insn);

    case 51:
      return split_112 (x1, insn);

    case 52:
      return split_111 (x1, insn);

    case 53:
      return split_110 (x1, insn);

    case 54:
      return split_109 (x1, insn);

    case 55:
      return split_108 (x1, insn);

    case 56:
      return split_107 (x1, insn);

    case 57:
      return split_106 (x1, insn);

    case 58:
      return split_105 (x1, insn);

    case 59:
      return split_104 (x1, insn);

    case 60:
      return split_103 (x1, insn);

    case 61:
      return split_102 (x1, insn);

    case 62:
      return split_101 (x1, insn);

    case 63:
      return split_100 (x1, insn);

    case 64:
      return split_99 (x1, insn);

    case 65:
      return split_98 (x1, insn);

    case 66:
      return split_97 (x1, insn);

    case 67:
      return split_96 (x1, insn);

    case 68:
      return split_95 (x1, insn);

    case 69:
      return split_94 (x1, insn);

    case 70:
      return split_93 (x1, insn);

    case 71:
      return split_92 (x1, insn);

    case 72:
      return split_91 (x1, insn);

    case 73:
      return split_90 (x1, insn);

    case 74:
      return split_89 (x1, insn);

    case 75:
      return split_88 (x1, insn);

    case 76:
      return split_87 (x1, insn);

    case 77:
      return split_86 (x1, insn);

    case 78:
      return split_85 (x1, insn);

    case 79:
      return split_84 (x1, insn);

    case 80:
      if (!(
#line 10172 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10174 "../../gcc/config/aarch64/aarch64-sve.md"
( (operands[4] != CONST0_RTX (VNx16BImode)
       || operands[5] != CONST0_RTX (VNx16BImode)))))
        return NULL;
      return gen_split_2679 (insn, operands);

    case 81:
      if (!(
#line 10196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10198 "../../gcc/config/aarch64/aarch64-sve.md"
( (operands[4] != CONST0_RTX (VNx16BImode)
       || operands[5] != CONST0_RTX (VNx16BImode)))))
        return NULL;
      return gen_split_2680 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          if (register_operand (operands[0], E_SImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2525 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern863 (x6, 
E_SImode) != 0
              || !
#line 3628 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return NULL;
          if (register_operand (operands[0], E_DImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2525 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), DImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern863 (x6, 
E_DImode) != 0
              || !
#line 3628 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              || !
#line 2537 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case SUBREG:
        case MEM:
          if (peep2_current_count < 2
              || pattern583 (x4, 
ZERO_EXTEND) != 0)
            return NULL;
          if (
#line 139 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_221 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 3)
            return NULL;
          x9 = PATTERN (peep2_next_insn (2));
          if (pattern1229 (x9, 
ZERO_EXTEND) != 0
              || !
#line 244 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_231 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (peep2_current_count < 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != COMPARE
          || GET_MODE (x10) != E_CCmode)
        return NULL;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 66
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return NULL;
      x13 = XEXP (x10, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1200 (x2, 
E_SImode) != 0
              || !
#line 3590 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        case E_DImode:
          if (pattern1200 (x2, 
E_DImode) != 0
              || !
#line 3590 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern41 (x1) != 0)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (aarch64_reg_or_zero (operands[2], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern933 (x6, 
E_SImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_6 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (aarch64_reg_or_zero (operands[2], E_DImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern933 (x6, 
E_DImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_7 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      operands[3] = x5;
      if (const_int_operand (operands[3], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern934 (x6, 
E_SImode) == 0
              && 
#line 3649 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!const_int_operand (operands[3], E_DImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern934 (x6, 
E_DImode) != 0
          || !
#line 3649 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      return peephole2_12 (x1, insn, pmatch_len_);

    case SIGN_EXTEND:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      if (pattern583 (x4, 
SIGN_EXTEND) != 0)
        return NULL;
      if (
#line 127 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_220 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 3)
        return NULL;
      x9 = PATTERN (peep2_next_insn (2));
      if (pattern1229 (x9, 
SIGN_EXTEND) != 0
          || !
#line 224 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_230 (insn, operands);

    default:
      return NULL;
    }
}
